/*     */ package com.jaspersoft.jasperserver.api.engine.scheduling.domain;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.JasperServerAPI;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.jaxb.AddressesXmlAdapter;
/*     */ import java.io.Serializable;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import javax.xml.bind.annotation.XmlRootElement;
/*     */ import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ @JasperServerAPI
/*     */ @XmlRootElement
/*     */ public class ReportJobAlert
/*     */   implements Serializable
/*     */ {
/*     */   private static final long serialVersionUID = 1L;
/*     */   private long id;
/*  52 */   private int version = -1;
/*  53 */   private Recipient recipient = Recipient.OWNER_AND_ADMIN;
/*  54 */   private List<String> toAddresses = new ArrayList();
/*  55 */   private JobState jobState = JobState.FAIL_ONLY;
/*  56 */   private String messageText = null;
/*  57 */   private String messageTextWhenJobFails = null;
/*  58 */   private String subject = null;
/*  59 */   private boolean includingStackTrace = true;
/*  60 */   private boolean includingReportJobInfo = true;
/*     */   
/*     */ 
/*     */ 
/*     */   public static enum Recipient
/*     */   {
/*  66 */     NONE((byte)0), 
/*  67 */     OWNER((byte)1), 
/*  68 */     ADMIN((byte)2), 
/*  69 */     OWNER_AND_ADMIN((byte)3);
/*     */     
/*     */ 
/*  72 */     private Recipient(byte code) { this.code = code; }
/*  73 */     public byte getCode() { return this.code; }
/*     */     
/*  75 */     public static Recipient fromCode(byte code) { for (Recipient b : ) if (code == b.code) return b;
/*  76 */       return NONE;
/*     */     }
/*     */     
/*     */     private byte code;
/*     */   }
/*     */   
/*     */   public static enum JobState
/*     */   {
/*  84 */     NONE((byte)0), 
/*  85 */     ALL((byte)1), 
/*  86 */     FAIL_ONLY((byte)2), 
/*  87 */     SUCCESS_ONLY((byte)3);
/*     */     
/*     */ 
/*  90 */     private JobState(byte code) { this.code = code; }
/*  91 */     public byte getCode() { return this.code; }
/*     */     
/*  93 */     public static JobState fromCode(byte code) { for (JobState b : ) if (code == b.code) return b;
/*  94 */       return NONE;
/*     */     }
/*     */     
/*     */ 
/*     */     private byte code;
/*     */   }
/*     */   
/*     */   public ReportJobAlert()
/*     */   {
/* 103 */     this.toAddresses = new ArrayList();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public long getId()
/*     */   {
/* 117 */     return this.id;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setId(long id)
/*     */   {
/* 131 */     this.id = id;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getVersion()
/*     */   {
/* 146 */     return this.version;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setVersion(int version)
/*     */   {
/* 161 */     this.version = version;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Recipient getRecipient()
/*     */   {
/* 171 */     return this.recipient;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setRecipient(Recipient recipient)
/*     */   {
/* 181 */     this.recipient = recipient;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlJavaTypeAdapter(AddressesXmlAdapter.class)
/*     */   public List<String> getToAddresses()
/*     */   {
/* 192 */     return this.toAddresses;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setToAddresses(List<String> toAddresses)
/*     */   {
/* 203 */     this.toAddresses = toAddresses;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JobState getJobState()
/*     */   {
/* 213 */     return this.jobState;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setJobState(JobState jobState)
/*     */   {
/* 223 */     this.jobState = jobState;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getMessageText()
/*     */   {
/* 237 */     return this.messageText;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setMessageText(String textMessage)
/*     */   {
/* 246 */     this.messageText = textMessage;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getMessageTextWhenJobFails()
/*     */   {
/* 260 */     return this.messageTextWhenJobFails;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setMessageTextWhenJobFails(String textMessageWhenFails)
/*     */   {
/* 269 */     this.messageTextWhenJobFails = textMessageWhenFails;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getSubject()
/*     */   {
/* 278 */     return this.subject;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setSubject(String subject)
/*     */   {
/* 287 */     this.subject = subject;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isIncludingReportJobInfo()
/*     */   {
/* 296 */     return this.includingReportJobInfo;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setIncludingReportJobInfo(boolean includingReportJobInfo)
/*     */   {
/* 305 */     this.includingReportJobInfo = includingReportJobInfo;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isIncludingStackTrace()
/*     */   {
/* 315 */     return this.includingStackTrace;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setIncludingStackTrace(boolean includingStackTrace)
/*     */   {
/* 324 */     this.includingStackTrace = includingStackTrace;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-api-engine-6.0.jar!\com\jaspersoft\jasperserver\api\engine\scheduling\domain\ReportJobAlert.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */