/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.importexport.exportservice;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.ExportFailedException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.common.ErrorDescriptor;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.importexport.StateDto;
/*     */ import java.io.InputStream;
/*     */ import java.util.Arrays;
/*     */ import java.util.concurrent.ExecutorService;
/*     */ import java.util.concurrent.Executors;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ExportRequestAdapter
/*     */   extends AbstractAdapter
/*     */ {
/*  42 */   private ExecutorService service = Executors.newFixedThreadPool(4);
/*     */   private static final String STATE_URI = "/state";
/*     */   private final String taskId;
/*     */   
/*     */   public ExportRequestAdapter(SessionStorage sessionStorage, String taskId)
/*     */   {
/*  48 */     super(sessionStorage);
/*  49 */     this.taskId = taskId;
/*     */   }
/*     */   
/*     */   public OperationResult<StateDto> state() {
/*  53 */     return JerseyRequest.buildRequest(this.sessionStorage, StateDto.class, new String[] { "/export", this.taskId, "/state" }).get();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncState(final Callback<OperationResult<StateDto>, R> callback) {
/*  57 */     final JerseyRequest<StateDto> request = JerseyRequest.buildRequest(this.sessionStorage, StateDto.class, new String[] { "/export", this.taskId, "/state" });
/*  58 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  61 */         callback.execute(request.get());
/*     */       }
/*  63 */     });
/*  64 */     ThreadPoolUtil.runAsynchronously(task);
/*  65 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<InputStream> fetch() {
/*     */     StateDto state;
/*  70 */     while (!"finished".equals((state = (StateDto)state().getEntity()).getPhase())) {
/*  71 */       if ("failed".equals(state.getPhase())) {
/*  72 */         if (state.getErrorDescriptor() != null) {
/*  73 */           throw new ExportFailedException(state.getErrorDescriptor().getMessage(), Arrays.asList(new ErrorDescriptor[] { state.getErrorDescriptor() }));
/*     */         }
/*  75 */         throw new ExportFailedException(state.getMessage());
/*     */       }
/*     */       try
/*     */       {
/*  79 */         Thread.sleep(500L);
/*     */       }
/*     */       catch (InterruptedException ignored) {}
/*     */     }
/*     */     
/*  84 */     JerseyRequest<InputStream> request = JerseyRequest.buildRequest(this.sessionStorage, InputStream.class, new String[] { "/export", this.taskId, "/exportFile" });
/*  85 */     request.setAccept("application/zip");
/*  86 */     return request.get();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncFetch(final Callback<OperationResult<InputStream>, R> callback) {
/*  90 */     final JerseyRequest<InputStream> request = JerseyRequest.buildRequest(this.sessionStorage, InputStream.class, new String[] { "/export", this.taskId, "/exportFile" });
/*  91 */     request.setAccept("application/zip");
/*  92 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*     */         StateDto state;
/*  96 */         while (!"finished".equals((state = (StateDto)ExportRequestAdapter.this.state().getEntity()).getPhase())) {
/*  97 */           if ("failed".equals(state.getPhase())) {
/*  98 */             if (state.getErrorDescriptor() != null) {
/*  99 */               throw new ExportFailedException(state.getErrorDescriptor().getMessage(), Arrays.asList(new ErrorDescriptor[] { state.getErrorDescriptor() }));
/*     */             }
/* 101 */             throw new ExportFailedException(state.getMessage());
/*     */           }
/*     */           try
/*     */           {
/* 105 */             Thread.sleep(500L);
/*     */           }
/*     */           catch (InterruptedException ignored) {}
/*     */         }
/*     */         
/* 110 */         callback.execute(request.get());
/*     */       }
/* 112 */     });
/* 113 */     ThreadPoolUtil.runAsynchronously(task);
/* 114 */     return task;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\importexport\exportservice\ExportRequestAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */