/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.resources.support.builder;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.dto.resources.ClientBundle;
/*     */ import com.jaspersoft.jasperserver.dto.resources.ClientFile;
/*     */ import com.jaspersoft.jasperserver.dto.resources.ClientReference;
/*     */ import com.jaspersoft.jasperserver.dto.resources.ClientSemanticLayerDataSource;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.resources.support.decorator.DomainResourceOperationProcessorDecorator;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.sun.jersey.multipart.FormDataMultiPart;
/*     */ import java.io.InputStream;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import javax.ws.rs.core.MediaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DomainResourceBuilder
/*     */   extends DomainResourceOperationProcessorDecorator
/*     */ {
/*  40 */   private int bundleCounter = 0;
/*     */   
/*     */   public DomainResourceBuilder(ClientSemanticLayerDataSource domain, SessionStorage sessionStorage) {
/*  43 */     super(sessionStorage, domain);
/*     */   }
/*     */   
/*     */   public DomainResourceBuilder withSchema(String schema, ClientFile schemaRef) {
/*  47 */     this.multipart.field("schema", schema, MediaType.APPLICATION_XML_TYPE);
/*  48 */     this.domain.setSchema(schemaRef);
/*  49 */     return this;
/*     */   }
/*     */   
/*     */   public DomainResourceBuilder withSchema(InputStream schema, ClientFile schemaRef) {
/*  53 */     this.multipart.field("schema", schema, MediaType.APPLICATION_XML_TYPE);
/*  54 */     this.domain.setSchema(schemaRef);
/*  55 */     return this;
/*     */   }
/*     */   
/*     */   public DomainResourceBuilder withSecurityFile(InputStream securityFile, ClientFile securityFileRef) {
/*  59 */     this.multipart.field("securityFile", securityFile, MediaType.APPLICATION_XML_TYPE);
/*  60 */     this.domain.setSecurityFile(securityFileRef);
/*  61 */     return this;
/*     */   }
/*     */   
/*     */   public DomainResourceBuilder withSecurityFile(String securityFile, ClientFile securityFileRef) {
/*  65 */     this.multipart.field("securityFile", securityFile, MediaType.APPLICATION_XML_TYPE);
/*  66 */     this.domain.setSecurityFile(securityFileRef);
/*  67 */     return this;
/*     */   }
/*     */   
/*     */   public DomainResourceBuilder withBundle(InputStream bundle, ClientBundle bundleRef) {
/*  71 */     this.multipart.field("bundles.bundle[" + this.bundleCounter++ + "]", bundle, MediaType.TEXT_PLAIN_TYPE);
/*  72 */     List<ClientBundle> bundles = this.domain.getBundles();
/*     */     
/*  74 */     if (bundles != null) {
/*  75 */       int index = bundles.indexOf(bundleRef);
/*  76 */       if (index >= 0) {
/*  77 */         bundles.set(index, bundleRef);
/*     */       } else {
/*  79 */         bundles.add(bundleRef);
/*     */       }
/*     */     } else {
/*  82 */       bundles = new ArrayList();
/*  83 */       bundles.add(bundleRef);
/*     */     }
/*     */     
/*  86 */     this.domain.setBundles(bundles);
/*  87 */     return this;
/*     */   }
/*     */   
/*     */   public DomainResourceBuilder withBundle(String bundle, ClientBundle bundleRef) {
/*  91 */     this.multipart.field("bundles.bundle[" + this.bundleCounter++ + "]", bundle, MediaType.TEXT_PLAIN_TYPE);
/*  92 */     List<ClientBundle> bundles = this.domain.getBundles();
/*     */     
/*  94 */     if (bundles != null) {
/*  95 */       int index = bundles.indexOf(bundleRef);
/*  96 */       if (index >= 0) {
/*  97 */         bundles.set(index, bundleRef);
/*     */       } else {
/*  99 */         bundles.add(bundleRef);
/*     */       }
/*     */     } else {
/* 102 */       bundles = new ArrayList();
/* 103 */       bundles.add(bundleRef);
/*     */     }
/*     */     
/* 106 */     this.domain.setBundles(bundles);
/* 107 */     return this;
/*     */   }
/*     */   
/*     */   public DomainResourceBuilder withBundles(List<InputStream> bundles, List<ClientBundle> bundlesRef) {
/* 111 */     for (InputStream bundle : bundles) {
/* 112 */       this.multipart.field("bundles.bundle[" + this.bundleCounter++ + "]", bundle, MediaType.TEXT_PLAIN_TYPE);
/*     */     }
/* 114 */     this.domain.setBundles(bundlesRef);
/* 115 */     return this;
/*     */   }
/*     */   
/*     */   public DomainResourceBuilder withDataSource(ClientReference dataSource) {
/* 119 */     this.domain.setDataSource(dataSource);
/* 120 */     return this;
/*     */   }
/*     */   
/*     */   public DomainResourceBuilder withUri(String uri) {
/* 124 */     this.domain.setUri(uri);
/* 125 */     return this;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\resources\support\builder\DomainResourceBuilder.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */