/*     */ package com.netapp.asup.data.function.sort;
/*     */ 
/*     */ import com.netapp.asup.client.arma.data.ARMAObjectInstance;
/*     */ import com.netapp.asup.data.function.FunctionAttribute;
/*     */ import com.netapp.asup.data.function.InputType;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Comparator;
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import org.apache.avro.generic.GenericData.Array;
/*     */ import org.apache.avro.generic.GenericRecord;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ public class PathComparator implements Comparator<ARMAObjectInstance>
/*     */ {
/*     */   private static final String SORT_TYPE = "sortType";
/*     */   private static final String ATTRIBUTE_TYPES = "attributeTypes";
/*     */   private static final String ATTR_TYPE = "attrType";
/*     */   private static final String ATTR_NAME = "attrName";
/*     */   private static final String EXPRESSION_TYPE = "expressionType";
/*     */   private static final String EXPRESSION = "expression";
/*     */   private static final String INPUT_TYPE = "inputType";
/*     */   private GenericData.Array<GenericRecord> sortFields;
/*     */   
/*     */   public PathComparator(GenericData.Array<GenericRecord> sortFields)
/*     */   {
/*  29 */     this.sortFields = sortFields;
/*     */   }
/*     */   
/*     */ 
/*     */   public int compare(ARMAObjectInstance o1, ARMAObjectInstance o2)
/*     */   {
/*  35 */     int result = 0;
/*  36 */     Iterator i$ = this.sortFields.iterator(); do { if (!i$.hasNext()) break; GenericRecord sortField = (GenericRecord)i$.next();
/*     */       
/*  38 */       InputType type = InputType.getInputType(String.valueOf(sortField.get("inputType")));
/*     */       
/*     */ 
/*  41 */       result = getComparator(type, sortField).compare(o1, o2);
/*     */     }
/*  43 */     while (result == 0);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  49 */     return result;
/*     */   }
/*     */   
/*     */ 
/*     */   private Comparator<ARMAObjectInstance> getComparator(InputType type, GenericRecord sortField)
/*     */   {
/*  55 */     switch (type) {
/*     */     case EXPRESSION: 
/*  57 */       String expression = String.valueOf(sortField.get("expression"));
/*  58 */       Class<?> expressionType = getClass(sortField.get("expressionType"));
/*  59 */       return new ExpressionComparator(getSortType(sortField), expression, expressionType, getAttributes(sortField));
/*     */     
/*     */ 
/*     */     case FUNCTION: 
/*  63 */       String function = String.valueOf(sortField.get("customFunction"));
/*  64 */       Map<String, String> options = getOptions(sortField);
/*  65 */       return new CustomComparator(function, options);
/*     */     }
/*  67 */     return new FieldComparator(getSortType(sortField), getAttributes(sortField));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private Map<String, String> getOptions(GenericRecord sortField)
/*     */   {
/*  75 */     Map<String, String> compareOptions = new HashMap();
/*     */     
/*  77 */     Map<Utf8, Utf8> options = (Map)sortField.get("options");
/*     */     
/*     */ 
/*  80 */     for (Utf8 key : options.keySet()) {
/*  81 */       compareOptions.put(key.toString(), ((Utf8)options.get(key)).toString());
/*     */     }
/*     */     
/*  84 */     return compareOptions;
/*     */   }
/*     */   
/*     */   private SortType getSortType(GenericRecord sortField) {
/*  88 */     SortType sortType = SortType.getSortType(String.valueOf(sortField.get("sortType")));
/*     */     
/*  90 */     return sortType;
/*     */   }
/*     */   
/*     */   private List<FunctionAttribute> getAttributes(GenericRecord sortField)
/*     */   {
/*  95 */     GenericData.Array<GenericRecord> attrs = (GenericData.Array)sortField.get("attributeTypes");
/*     */     
/*     */ 
/*  98 */     List<FunctionAttribute> funcAtts = new ArrayList(attrs.size());
/*     */     
/* 100 */     for (GenericRecord attr : attrs)
/*     */     {
/* 102 */       funcAtts.add(new FunctionAttribute(String.valueOf(attr.get("attrName")), getClass(attr.get("attrType"))));
/*     */     }
/*     */     
/* 105 */     return funcAtts;
/*     */   }
/*     */   
/*     */   private static Class<?> getClass(Object object) {
/* 109 */     String attributeType = String.valueOf(object.toString());
/*     */     try {
/* 111 */       return Class.forName(attributeType);
/*     */     } catch (ClassNotFoundException e) {
/* 113 */       throw new IllegalArgumentException("Invalid Attribute type:" + attributeType);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\sort\PathComparator.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */