/*     */ package com.sun.xml.bind;
/*     */ 
/*     */ import com.sun.xml.bind.v2.TODO;
/*     */ import java.math.BigDecimal;
/*     */ import java.math.BigInteger;
/*     */ import java.util.Calendar;
/*     */ import java.util.GregorianCalendar;
/*     */ import java.util.TimeZone;
/*     */ import javax.xml.bind.DatatypeConverter;
/*     */ import javax.xml.bind.DatatypeConverterInterface;
/*     */ import javax.xml.datatype.DatatypeConfigurationException;
/*     */ import javax.xml.datatype.DatatypeFactory;
/*     */ import javax.xml.datatype.XMLGregorianCalendar;
/*     */ import javax.xml.namespace.NamespaceContext;
/*     */ import javax.xml.namespace.QName;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class DatatypeConverterImpl
/*     */   implements DatatypeConverterInterface
/*     */ {
/*     */   public static final DatatypeConverterInterface theInstance;
/*     */   private static final char[] hexCode;
/*     */   private static final byte[] decodeMap;
/*     */   private static final byte PADDING = 127;
/*     */   private static final char[] encodeMap;
/*     */   private static final DatatypeFactory datatypeFactory;
/*     */   
/*     */   public String parseString(String lexicalXSDString)
/*     */   {
/*  64 */     return lexicalXSDString;
/*     */   }
/*     */   
/*     */   public BigInteger parseInteger(String lexicalXSDInteger) {
/*  68 */     return _parseInteger(lexicalXSDInteger);
/*     */   }
/*     */   
/*     */   public static BigInteger _parseInteger(CharSequence s) {
/*  72 */     return new BigInteger(removeOptionalPlus(WhiteSpaceProcessor.trim(s)).toString());
/*     */   }
/*     */   
/*     */   public String printInteger(BigInteger val) {
/*  76 */     return _printInteger(val);
/*     */   }
/*     */   
/*     */   public static String _printInteger(BigInteger val) {
/*  80 */     return val.toString();
/*     */   }
/*     */   
/*     */   public int parseInt(String s) {
/*  84 */     return _parseInt(s);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static int _parseInt(CharSequence s)
/*     */   {
/*  98 */     int len = s.length();
/*  99 */     int sign = 1;
/*     */     
/* 101 */     int r = 0;
/*     */     
/* 103 */     for (int i = 0; i < len; i++) {
/* 104 */       char ch = s.charAt(i);
/* 105 */       if (!WhiteSpaceProcessor.isWhiteSpace(ch))
/*     */       {
/*     */ 
/* 108 */         if (('0' <= ch) && (ch <= '9')) {
/* 109 */           r = r * 10 + (ch - '0');
/*     */         }
/* 111 */         else if (ch == '-') {
/* 112 */           sign = -1;
/*     */         }
/* 114 */         else if (ch != '+')
/*     */         {
/*     */ 
/* 117 */           throw new NumberFormatException("Not a number: " + s); }
/*     */       }
/*     */     }
/* 120 */     return r * sign;
/*     */   }
/*     */   
/*     */   public long parseLong(String lexicalXSLong) {
/* 124 */     return _parseLong(lexicalXSLong);
/*     */   }
/*     */   
/*     */   public static long _parseLong(CharSequence s) {
/* 128 */     return Long.valueOf(removeOptionalPlus(WhiteSpaceProcessor.trim(s)).toString()).longValue();
/*     */   }
/*     */   
/*     */   public short parseShort(String lexicalXSDShort) {
/* 132 */     return _parseShort(lexicalXSDShort);
/*     */   }
/*     */   
/*     */   public static final short _parseShort(CharSequence s) {
/* 136 */     return (short)_parseInt(s);
/*     */   }
/*     */   
/*     */   public String printShort(short val) {
/* 140 */     return _printShort(val);
/*     */   }
/*     */   
/*     */   public static String _printShort(short val) {
/* 144 */     return String.valueOf(val);
/*     */   }
/*     */   
/*     */ 
/* 148 */   public BigDecimal parseDecimal(String content) { return _parseDecimal(content); }
/*     */   
/*     */   public static BigDecimal _parseDecimal(CharSequence content) {
/* 151 */     content = WhiteSpaceProcessor.trim(content);
/*     */     
/* 153 */     return new BigDecimal(content.toString());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public float parseFloat(String lexicalXSDFloat)
/*     */   {
/* 169 */     return _parseFloat(lexicalXSDFloat);
/*     */   }
/*     */   
/*     */   public static float _parseFloat(CharSequence _val) {
/* 173 */     String s = WhiteSpaceProcessor.trim(_val).toString();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 189 */     if (s.equals("NaN")) return NaN.0F;
/* 190 */     if (s.equals("INF")) return Float.POSITIVE_INFINITY;
/* 191 */     if (s.equals("-INF")) { return Float.NEGATIVE_INFINITY;
/*     */     }
/* 193 */     if ((s.length() == 0) || (!isDigitOrPeriodOrSign(s.charAt(0))) || (!isDigitOrPeriodOrSign(s.charAt(s.length() - 1))))
/*     */     {
/*     */ 
/* 196 */       throw new NumberFormatException();
/*     */     }
/*     */     
/* 199 */     return Float.parseFloat(s);
/*     */   }
/*     */   
/*     */   public String printFloat(float v) {
/* 203 */     return _printFloat(v);
/*     */   }
/*     */   
/*     */   public static String _printFloat(float v) {
/* 207 */     if (v == NaN.0F) return "NaN";
/* 208 */     if (v == Float.POSITIVE_INFINITY) return "INF";
/* 209 */     if (v == Float.NEGATIVE_INFINITY) return "-INF";
/* 210 */     return String.valueOf(v);
/*     */   }
/*     */   
/*     */ 
/*     */   public double parseDouble(String lexicalXSDDouble)
/*     */   {
/* 216 */     return _parseDouble(lexicalXSDDouble);
/*     */   }
/*     */   
/*     */   public static double _parseDouble(CharSequence _val) {
/* 220 */     String val = WhiteSpaceProcessor.trim(_val).toString();
/*     */     
/* 222 */     if (val.equals("NaN")) return NaN.0D;
/* 223 */     if (val.equals("INF")) return Double.POSITIVE_INFINITY;
/* 224 */     if (val.equals("-INF")) { return Double.NEGATIVE_INFINITY;
/*     */     }
/* 226 */     if ((val.length() == 0) || (!isDigitOrPeriodOrSign(val.charAt(0))) || (!isDigitOrPeriodOrSign(val.charAt(val.length() - 1))))
/*     */     {
/*     */ 
/* 229 */       throw new NumberFormatException(val);
/*     */     }
/*     */     
/*     */ 
/* 233 */     return Double.parseDouble(val);
/*     */   }
/*     */   
/*     */   public boolean parseBoolean(String lexicalXSDBoolean) {
/* 237 */     return _parseBoolean(lexicalXSDBoolean);
/*     */   }
/*     */   
/*     */   public static boolean _parseBoolean(CharSequence literal) {
/* 241 */     int i = 0;
/* 242 */     int len = literal.length();
/*     */     char ch;
/*     */     do {
/* 245 */       ch = literal.charAt(i++);
/* 246 */     } while ((WhiteSpaceProcessor.isWhiteSpace(ch)) && (i < len));
/*     */     
/*     */ 
/*     */ 
/* 250 */     if ((ch == 't') || (ch == '1')) return true;
/* 251 */     if ((ch == 'f') || (ch == '0')) return false;
/* 252 */     TODO.checkSpec("issue #42");
/* 253 */     return false;
/*     */   }
/*     */   
/*     */   public String printBoolean(boolean val) {
/* 257 */     return val ? "true" : "false";
/*     */   }
/*     */   
/* 260 */   public static String _printBoolean(boolean val) { return val ? "true" : "false"; }
/*     */   
/*     */   public byte parseByte(String lexicalXSDByte)
/*     */   {
/* 264 */     return _parseByte(lexicalXSDByte);
/*     */   }
/*     */   
/*     */   public static byte _parseByte(CharSequence literal) {
/* 268 */     return (byte)_parseInt(literal);
/*     */   }
/*     */   
/*     */   public String printByte(byte val) {
/* 272 */     return _printByte(val);
/*     */   }
/*     */   
/*     */   public static String _printByte(byte val) {
/* 276 */     return String.valueOf(val);
/*     */   }
/*     */   
/*     */   public QName parseQName(String lexicalXSDQName, NamespaceContext nsc) {
/* 280 */     return _parseQName(lexicalXSDQName, nsc);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public static QName _parseQName(CharSequence text, NamespaceContext nsc)
/*     */   {
/* 287 */     int length = text.length();
/*     */     
/*     */ 
/* 290 */     int start = 0;
/* 291 */     while ((start < length) && (WhiteSpaceProcessor.isWhiteSpace(text.charAt(start)))) {
/* 292 */       start++;
/*     */     }
/* 294 */     int end = length;
/* 295 */     while ((end > start) && (WhiteSpaceProcessor.isWhiteSpace(text.charAt(end - 1)))) {
/* 296 */       end--;
/*     */     }
/* 298 */     if (end == start) {
/* 299 */       throw new IllegalArgumentException("input is empty");
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 307 */     int idx = start + 1;
/* 308 */     while ((idx < end) && (text.charAt(idx) != ':'))
/* 309 */       idx++;
/*     */     String prefix;
/* 311 */     String prefix; String localPart; String uri; if (idx == end) {
/* 312 */       String uri = nsc.getNamespaceURI("");
/* 313 */       String localPart = text.subSequence(start, end).toString();
/* 314 */       prefix = "";
/*     */     }
/*     */     else {
/* 317 */       prefix = text.subSequence(start, idx).toString();
/* 318 */       localPart = text.subSequence(idx + 1, end).toString();
/* 319 */       uri = nsc.getNamespaceURI(prefix);
/*     */       
/*     */ 
/* 322 */       if ((uri == null) || (uri.length() == 0))
/*     */       {
/* 324 */         throw new IllegalArgumentException("prefix " + prefix + " is not bound to a namespace");
/*     */       }
/*     */     }
/* 327 */     return new QName(uri, localPart, prefix);
/*     */   }
/*     */   
/*     */   public Calendar parseDateTime(String lexicalXSDDateTime) {
/* 331 */     return _parseDateTime(lexicalXSDDateTime);
/*     */   }
/*     */   
/*     */   public static GregorianCalendar _parseDateTime(CharSequence s) {
/* 335 */     String val = WhiteSpaceProcessor.trim(s).toString();
/* 336 */     return datatypeFactory.newXMLGregorianCalendar(val).toGregorianCalendar();
/*     */   }
/*     */   
/*     */   public String printDateTime(Calendar val) {
/* 340 */     return _printDateTime(val);
/*     */   }
/*     */   
/*     */   public static String _printDateTime(Calendar val) {
/* 344 */     return CalendarFormatter.doFormat("%Y-%M-%DT%h:%m:%s%z", val);
/*     */   }
/*     */   
/*     */   public byte[] parseBase64Binary(String lexicalXSDBase64Binary) {
/* 348 */     return _parseBase64Binary(lexicalXSDBase64Binary);
/*     */   }
/*     */   
/*     */   public byte[] parseHexBinary(String s)
/*     */   {
/* 353 */     int len = s.length();
/*     */     
/*     */ 
/* 356 */     if (len % 2 != 0) { return null;
/*     */     }
/* 358 */     byte[] out = new byte[len / 2];
/*     */     
/* 360 */     for (int i = 0; i < len; i += 2) {
/* 361 */       int h = hexToBin(s.charAt(i));
/* 362 */       int l = hexToBin(s.charAt(i + 1));
/* 363 */       if ((h == -1) || (l == -1)) {
/* 364 */         return null;
/*     */       }
/* 366 */       out[(i / 2)] = ((byte)(h * 16 + l));
/*     */     }
/*     */     
/* 369 */     return out;
/*     */   }
/*     */   
/*     */   private static int hexToBin(char ch) {
/* 373 */     if (('0' <= ch) && (ch <= '9')) return ch - '0';
/* 374 */     if (('A' <= ch) && (ch <= 'F')) return ch - 'A' + 10;
/* 375 */     if (('a' <= ch) && (ch <= 'f')) return ch - 'a' + 10;
/* 376 */     return -1;
/*     */   }
/*     */   
/*     */ 
/*     */   public String printHexBinary(byte[] data)
/*     */   {
/* 382 */     StringBuilder r = new StringBuilder(data.length * 2);
/* 383 */     for (byte b : data) {
/* 384 */       r.append(hexCode[(b >> 4 & 0xF)]);
/* 385 */       r.append(hexCode[(b & 0xF)]);
/*     */     }
/* 387 */     return r.toString();
/*     */   }
/*     */   
/*     */   public long parseUnsignedInt(String lexicalXSDUnsignedInt)
/*     */   {
/* 392 */     return _parseLong(lexicalXSDUnsignedInt);
/*     */   }
/*     */   
/*     */   public String printUnsignedInt(long val) {
/* 396 */     return _printLong(val);
/*     */   }
/*     */   
/*     */   public int parseUnsignedShort(String lexicalXSDUnsignedShort) {
/* 400 */     return _parseInt(lexicalXSDUnsignedShort);
/*     */   }
/*     */   
/*     */   public Calendar parseTime(String lexicalXSDTime) {
/* 404 */     return datatypeFactory.newXMLGregorianCalendar(lexicalXSDTime).toGregorianCalendar();
/*     */   }
/*     */   
/*     */   public String printTime(Calendar val) {
/* 408 */     return CalendarFormatter.doFormat("%h:%m:%s%z", val);
/*     */   }
/*     */   
/*     */   public Calendar parseDate(String lexicalXSDDate) {
/* 412 */     return datatypeFactory.newXMLGregorianCalendar(lexicalXSDDate).toGregorianCalendar();
/*     */   }
/*     */   
/*     */   public String printDate(Calendar val)
/*     */   {
/* 417 */     return CalendarFormatter.doFormat("%Y-%M-%D" + "%z", val);
/*     */   }
/*     */   
/*     */   public String parseAnySimpleType(String lexicalXSDAnySimpleType) {
/* 421 */     return lexicalXSDAnySimpleType;
/*     */   }
/*     */   
/*     */ 
/*     */   public String printString(String val)
/*     */   {
/* 427 */     return val;
/*     */   }
/*     */   
/*     */   public String printInt(int val)
/*     */   {
/* 432 */     return _printInt(val);
/*     */   }
/*     */   
/*     */   public static String _printInt(int val) {
/* 436 */     return String.valueOf(val);
/*     */   }
/*     */   
/*     */   public String printLong(long val) {
/* 440 */     return _printLong(val);
/*     */   }
/*     */   
/*     */   public static String _printLong(long val) {
/* 444 */     return String.valueOf(val);
/*     */   }
/*     */   
/*     */   public String printDecimal(BigDecimal val) {
/* 448 */     return _printDecimal(val);
/*     */   }
/*     */   
/*     */   public static String _printDecimal(BigDecimal val) {
/* 452 */     return val.toString();
/*     */   }
/*     */   
/*     */   public String printDouble(double v) {
/* 456 */     return _printDouble(v);
/*     */   }
/*     */   
/*     */   public static String _printDouble(double v) {
/* 460 */     if (v == NaN.0D) return "NaN";
/* 461 */     if (v == Double.POSITIVE_INFINITY) return "INF";
/* 462 */     if (v == Double.NEGATIVE_INFINITY) return "-INF";
/* 463 */     return String.valueOf(v);
/*     */   }
/*     */   
/*     */   public String printQName(QName val, NamespaceContext nsc) {
/* 467 */     return _printQName(val, nsc);
/*     */   }
/*     */   
/*     */ 
/*     */   public static String _printQName(QName val, NamespaceContext nsc)
/*     */   {
/* 473 */     String prefix = nsc.getPrefix(val.getNamespaceURI());
/* 474 */     String localPart = val.getLocalPart();
/*     */     String qname;
/* 476 */     String qname; if ((prefix == null) || (prefix.length() == 0)) {
/* 477 */       qname = localPart;
/*     */     } else {
/* 479 */       qname = prefix + ':' + localPart;
/*     */     }
/*     */     
/* 482 */     return qname;
/*     */   }
/*     */   
/*     */   public String printBase64Binary(byte[] val) {
/* 486 */     return _printBase64Binary(val);
/*     */   }
/*     */   
/*     */   public String printUnsignedShort(int val) {
/* 490 */     return String.valueOf(val);
/*     */   }
/*     */   
/*     */   public String printAnySimpleType(String val) {
/* 494 */     return val;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static String installHook(String s)
/*     */   {
/* 504 */     DatatypeConverter.setDatatypeConverter(theInstance);
/* 505 */     return s;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static byte[] initDecodeMap()
/*     */   {
/* 518 */     byte[] map = new byte[''];
/*     */     
/* 520 */     for (int i = 0; i < 128; i++) { map[i] = -1;
/*     */     }
/* 522 */     for (i = 65; i <= 90; i++) map[i] = ((byte)(i - 65));
/* 523 */     for (i = 97; i <= 122; i++) map[i] = ((byte)(i - 97 + 26));
/* 524 */     for (i = 48; i <= 57; i++) map[i] = ((byte)(i - 48 + 52));
/* 525 */     map[43] = 62;
/* 526 */     map[47] = 63;
/* 527 */     map[61] = Byte.MAX_VALUE;
/*     */     
/* 529 */     return map;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static int calcLength(String text)
/*     */   {
/* 540 */     int len = text.length();
/* 541 */     int base64count = 0;
/*     */     
/*     */ 
/* 544 */     for (int i = 0; i < len; i++) {
/* 545 */       char ch = text.charAt(i);
/* 546 */       if (ch == '=')
/*     */         break;
/* 548 */       if (ch >= '')
/* 549 */         return -1;
/* 550 */       if (decodeMap[ch] != -1) {
/* 551 */         base64count++;
/*     */       }
/*     */     }
/* 554 */     return base64count / 4 * 3 + Math.max(0, base64count % 4 - 1);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static byte[] _parseBase64Binary(String text)
/*     */   {
/* 567 */     int outlen = calcLength(text);
/* 568 */     if (outlen == -1) return null;
/* 569 */     byte[] out = new byte[outlen];
/* 570 */     int o = 0;
/*     */     
/* 572 */     int len = text.length();
/*     */     
/*     */ 
/* 575 */     byte[] quadruplet = new byte[4];
/* 576 */     int q = 0;
/*     */     
/*     */ 
/* 579 */     for (int i = 0; i < len; i++) {
/* 580 */       char ch = text.charAt(i);
/* 581 */       byte v = decodeMap[ch];
/* 582 */       if (v != -1) {
/* 583 */         quadruplet[(q++)] = v;
/*     */       }
/* 585 */       if (q == 4)
/*     */       {
/* 587 */         out[(o++)] = ((byte)(quadruplet[0] << 2 | quadruplet[1] >> 4));
/* 588 */         if (quadruplet[2] != Byte.MAX_VALUE)
/* 589 */           out[(o++)] = ((byte)(quadruplet[1] << 4 | quadruplet[2] >> 2));
/* 590 */         if (quadruplet[3] != Byte.MAX_VALUE)
/* 591 */           out[(o++)] = ((byte)(quadruplet[2] << 6 | quadruplet[3]));
/* 592 */         q = 0;
/*     */       }
/*     */     }
/*     */     
/* 596 */     return out;
/*     */   }
/*     */   
/*     */ 
/*     */   private static char[] initEncodeMap()
/*     */   {
/* 602 */     char[] map = new char[64];
/*     */     
/* 604 */     for (int i = 0; i < 26; i++) map[i] = ((char)(65 + i));
/* 605 */     for (i = 26; i < 52; i++) map[i] = ((char)(97 + (i - 26)));
/* 606 */     for (i = 52; i < 62; i++) map[i] = ((char)(48 + (i - 52)));
/* 607 */     map[62] = '+';
/* 608 */     map[63] = '/';
/*     */     
/* 610 */     return map;
/*     */   }
/*     */   
/*     */   public static char encode(int i) {
/* 614 */     return encodeMap[(i & 0x3F)];
/*     */   }
/*     */   
/*     */   public static byte encodeByte(int i) {
/* 618 */     return (byte)encodeMap[(i & 0x3F)];
/*     */   }
/*     */   
/*     */ 
/* 622 */   public static String _printBase64Binary(byte[] input) { return _printBase64Binary(input, 0, input.length); }
/*     */   
/*     */   public static String _printBase64Binary(byte[] input, int offset, int len) {
/* 625 */     char[] buf = new char[(len + 2) / 3 * 4];
/* 626 */     int ptr = _printBase64Binary(input, offset, len, buf, 0);
/* 627 */     assert (ptr == buf.length);
/* 628 */     return new String(buf);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static int _printBase64Binary(byte[] input, int offset, int len, char[] buf, int ptr)
/*     */   {
/* 641 */     for (int i = offset; i < len; i += 3) {
/* 642 */       switch (len - i) {
/*     */       case 1: 
/* 644 */         buf[(ptr++)] = encode(input[i] >> 2);
/* 645 */         buf[(ptr++)] = encode((input[i] & 0x3) << 4);
/* 646 */         buf[(ptr++)] = '=';
/* 647 */         buf[(ptr++)] = '=';
/* 648 */         break;
/*     */       case 2: 
/* 650 */         buf[(ptr++)] = encode(input[i] >> 2);
/* 651 */         buf[(ptr++)] = encode((input[i] & 0x3) << 4 | input[(i + 1)] >> 4 & 0xF);
/*     */         
/*     */ 
/* 654 */         buf[(ptr++)] = encode((input[(i + 1)] & 0xF) << 2);
/* 655 */         buf[(ptr++)] = '=';
/* 656 */         break;
/*     */       default: 
/* 658 */         buf[(ptr++)] = encode(input[i] >> 2);
/* 659 */         buf[(ptr++)] = encode((input[i] & 0x3) << 4 | input[(i + 1)] >> 4 & 0xF);
/*     */         
/*     */ 
/* 662 */         buf[(ptr++)] = encode((input[(i + 1)] & 0xF) << 2 | input[(i + 2)] >> 6 & 0x3);
/*     */         
/*     */ 
/* 665 */         buf[(ptr++)] = encode(input[(i + 2)] & 0x3F);
/*     */       }
/*     */       
/*     */     }
/* 669 */     return ptr;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static int _printBase64Binary(byte[] input, int offset, int len, byte[] out, int ptr)
/*     */   {
/* 683 */     byte[] buf = out;
/* 684 */     int max = len + offset;
/* 685 */     for (int i = offset; i < max; i += 3) {
/* 686 */       switch (max - i) {
/*     */       case 1: 
/* 688 */         buf[(ptr++)] = encodeByte(input[i] >> 2);
/* 689 */         buf[(ptr++)] = encodeByte((input[i] & 0x3) << 4);
/* 690 */         buf[(ptr++)] = 61;
/* 691 */         buf[(ptr++)] = 61;
/* 692 */         break;
/*     */       case 2: 
/* 694 */         buf[(ptr++)] = encodeByte(input[i] >> 2);
/* 695 */         buf[(ptr++)] = encodeByte((input[i] & 0x3) << 4 | input[(i + 1)] >> 4 & 0xF);
/*     */         
/*     */ 
/* 698 */         buf[(ptr++)] = encodeByte((input[(i + 1)] & 0xF) << 2);
/* 699 */         buf[(ptr++)] = 61;
/* 700 */         break;
/*     */       default: 
/* 702 */         buf[(ptr++)] = encodeByte(input[i] >> 2);
/* 703 */         buf[(ptr++)] = encodeByte((input[i] & 0x3) << 4 | input[(i + 1)] >> 4 & 0xF);
/*     */         
/*     */ 
/* 706 */         buf[(ptr++)] = encodeByte((input[(i + 1)] & 0xF) << 2 | input[(i + 2)] >> 6 & 0x3);
/*     */         
/*     */ 
/* 709 */         buf[(ptr++)] = encodeByte(input[(i + 2)] & 0x3F);
/*     */       }
/*     */       
/*     */     }
/*     */     
/* 714 */     return ptr;
/*     */   }
/*     */   
/*     */   private static CharSequence removeOptionalPlus(CharSequence s) {
/* 718 */     int len = s.length();
/*     */     
/* 720 */     if ((len <= 1) || (s.charAt(0) != '+')) { return s;
/*     */     }
/* 722 */     s = s.subSequence(1, len);
/* 723 */     char ch = s.charAt(0);
/* 724 */     if (('0' <= ch) && (ch <= '9')) return s;
/* 725 */     if ('.' == ch) { return s;
/*     */     }
/* 727 */     throw new NumberFormatException();
/*     */   }
/*     */   
/*     */   private static boolean isDigitOrPeriodOrSign(char ch) {
/* 731 */     if (('0' <= ch) && (ch <= '9')) return true;
/* 732 */     if ((ch == '+') || (ch == '-') || (ch == '.')) return true;
/* 733 */     return false;
/*     */   }
/*     */   
/*     */   static
/*     */   {
/*  58 */     theInstance = new DatatypeConverterImpl();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 379 */     hexCode = "0123456789ABCDEF".toCharArray();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 514 */     decodeMap = initDecodeMap();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 599 */     encodeMap = initEncodeMap();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     try
/*     */     {
/* 740 */       datatypeFactory = DatatypeFactory.newInstance();
/*     */     } catch (DatatypeConfigurationException e) {
/* 742 */       throw new Error(e);
/*     */     }
/*     */   }
/*     */   
/*     */   private static final class CalendarFormatter
/*     */   {
/*     */     public static String doFormat(String format, Calendar cal) throws IllegalArgumentException {
/* 749 */       int fidx = 0;
/* 750 */       int flen = format.length();
/* 751 */       StringBuilder buf = new StringBuilder();
/*     */       
/* 753 */       while (fidx < flen) {
/* 754 */         char fch = format.charAt(fidx++);
/*     */         
/* 756 */         if (fch != '%') {
/* 757 */           buf.append(fch);
/*     */ 
/*     */         }
/*     */         else
/*     */         {
/* 762 */           switch (format.charAt(fidx++)) {
/*     */           case 'Y': 
/* 764 */             formatYear(cal, buf);
/* 765 */             break;
/*     */           
/*     */           case 'M': 
/* 768 */             formatMonth(cal, buf);
/* 769 */             break;
/*     */           
/*     */           case 'D': 
/* 772 */             formatDays(cal, buf);
/* 773 */             break;
/*     */           
/*     */           case 'h': 
/* 776 */             formatHours(cal, buf);
/* 777 */             break;
/*     */           
/*     */           case 'm': 
/* 780 */             formatMinutes(cal, buf);
/* 781 */             break;
/*     */           
/*     */           case 's': 
/* 784 */             formatSeconds(cal, buf);
/* 785 */             break;
/*     */           
/*     */           case 'z': 
/* 788 */             formatTimeZone(cal, buf);
/* 789 */             break;
/*     */           
/*     */ 
/*     */           default: 
/* 793 */             throw new InternalError();
/*     */           }
/*     */         }
/*     */       }
/* 797 */       return buf.toString();
/*     */     }
/*     */     
/*     */     private static void formatYear(Calendar cal, StringBuilder buf)
/*     */     {
/* 802 */       int year = cal.get(1);
/*     */       String s;
/*     */       String s;
/* 805 */       if (year <= 0) {
/* 806 */         s = Integer.toString(1 - year);
/*     */       } else {
/* 808 */         s = Integer.toString(year);
/*     */       }
/* 810 */       while (s.length() < 4)
/* 811 */         s = '0' + s;
/* 812 */       if (year <= 0) {
/* 813 */         s = '-' + s;
/*     */       }
/* 815 */       buf.append(s);
/*     */     }
/*     */     
/*     */     private static void formatMonth(Calendar cal, StringBuilder buf) {
/* 819 */       formatTwoDigits(cal.get(2) + 1, buf);
/*     */     }
/*     */     
/*     */     private static void formatDays(Calendar cal, StringBuilder buf) {
/* 823 */       formatTwoDigits(cal.get(5), buf);
/*     */     }
/*     */     
/*     */     private static void formatHours(Calendar cal, StringBuilder buf) {
/* 827 */       formatTwoDigits(cal.get(11), buf);
/*     */     }
/*     */     
/*     */     private static void formatMinutes(Calendar cal, StringBuilder buf) {
/* 831 */       formatTwoDigits(cal.get(12), buf);
/*     */     }
/*     */     
/*     */     private static void formatSeconds(Calendar cal, StringBuilder buf) {
/* 835 */       formatTwoDigits(cal.get(13), buf);
/* 836 */       if (cal.isSet(14)) {
/* 837 */         int n = cal.get(14);
/* 838 */         if (n != 0) {
/* 839 */           String ms = Integer.toString(n);
/* 840 */           while (ms.length() < 3) {
/* 841 */             ms = '0' + ms;
/*     */           }
/* 843 */           buf.append('.');
/* 844 */           buf.append(ms);
/*     */         }
/*     */       }
/*     */     }
/*     */     
/*     */     private static void formatTimeZone(Calendar cal, StringBuilder buf)
/*     */     {
/* 851 */       TimeZone tz = cal.getTimeZone();
/*     */       
/* 853 */       if (tz == null)
/*     */         return;
/*     */       int offset;
/*     */       int offset;
/* 857 */       if (tz.inDaylightTime(cal.getTime())) {
/* 858 */         offset = tz.getRawOffset() + (tz.useDaylightTime() ? 3600000 : 0);
/*     */       } else {
/* 860 */         offset = tz.getRawOffset();
/*     */       }
/*     */       
/* 863 */       if (offset >= 0) {
/* 864 */         buf.append('+');
/*     */       } else {
/* 866 */         buf.append('-');
/* 867 */         offset *= -1;
/*     */       }
/*     */       
/* 870 */       offset /= 60000;
/*     */       
/* 872 */       formatTwoDigits(offset / 60, buf);
/* 873 */       buf.append(':');
/* 874 */       formatTwoDigits(offset % 60, buf);
/*     */     }
/*     */     
/*     */ 
/*     */     private static final void formatTwoDigits(int n, StringBuilder buf)
/*     */     {
/* 880 */       if (n < 10) buf.append('0');
/* 881 */       buf.append(n);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\DatatypeConverterImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */