/*     */ package com.sun.xml.bind.api.impl;
/*     */ 
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashSet;
/*     */ import java.util.List;
/*     */ 
/*     */ 
/*     */ 
/*     */ class NameUtil
/*     */ {
/*     */   protected static final int UPPER_LETTER = 0;
/*     */   protected static final int LOWER_LETTER = 1;
/*     */   protected static final int OTHER_LETTER = 2;
/*     */   protected static final int DIGIT = 3;
/*     */   protected static final int OTHER = 4;
/*     */   
/*     */   protected boolean isPunct(char c)
/*     */   {
/*  19 */     return (c == '-') || (c == '.') || (c == ':') || (c == '_') || (c == '·') || (c == '·') || (c == '۝') || (c == '۞');
/*     */   }
/*     */   
/*     */   protected static boolean isDigit(char c) {
/*  23 */     return ((c >= '0') && (c <= '9')) || (Character.isDigit(c));
/*     */   }
/*     */   
/*     */   protected static boolean isUpper(char c) {
/*  27 */     return ((c >= 'A') && (c <= 'Z')) || (Character.isUpperCase(c));
/*     */   }
/*     */   
/*     */   protected static boolean isLower(char c) {
/*  31 */     return ((c >= 'a') && (c <= 'z')) || (Character.isLowerCase(c));
/*     */   }
/*     */   
/*     */   protected boolean isLetter(char c) {
/*  35 */     return ((c >= 'A') && (c <= 'Z')) || ((c >= 'a') && (c <= 'z')) || (Character.isLetter(c));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public String capitalize(String s)
/*     */   {
/*  43 */     if (!isLower(s.charAt(0)))
/*  44 */       return s;
/*  45 */     StringBuilder sb = new StringBuilder(s.length());
/*  46 */     sb.append(Character.toUpperCase(s.charAt(0)));
/*  47 */     sb.append(s.substring(1).toLowerCase());
/*  48 */     return sb.toString();
/*     */   }
/*     */   
/*     */   private int nextBreak(String s, int start)
/*     */   {
/*  53 */     int n = s.length();
/*     */     
/*  55 */     char c1 = s.charAt(start);
/*  56 */     int t1 = classify(c1);
/*     */     
/*  58 */     for (int i = start + 1; i < n; i++)
/*     */     {
/*     */ 
/*  61 */       int t0 = t1;
/*     */       
/*  63 */       c1 = s.charAt(i);
/*  64 */       t1 = classify(c1);
/*     */       
/*  66 */       switch (actionTable[(t0 * 5 + t1)]) {
/*     */       case 0: 
/*  68 */         if (isPunct(c1)) return i;
/*     */         break;
/*     */       case 1: 
/*  71 */         if (i < n - 1) {
/*  72 */           char c2 = s.charAt(i + 1);
/*  73 */           if (isLower(c2))
/*  74 */             return i; }
/*  75 */         break;
/*     */       
/*     */       case 2: 
/*  78 */         return i;
/*     */       }
/*     */     }
/*  81 */     return -1;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  96 */   private static final byte[] actionTable = new byte[25];
/*     */   
/*     */   private static final byte ACTION_CHECK_PUNCT = 0;
/*     */   
/*     */   private static final byte ACTION_CHECK_C2 = 1;
/*     */   
/*     */   private static final byte ACTION_BREAK = 2;
/*     */   
/*     */   private static final byte ACTION_NOBREAK = 3;
/*     */   
/*     */   private static HashSet<String> reservedKeywords;
/*     */   
/*     */   private static byte decideAction(int t0, int t1)
/*     */   {
/* 110 */     if ((t0 == 4) && (t1 == 4)) return 0;
/* 111 */     if (!xor(t0 == 3, t1 == 3)) return 2;
/* 112 */     if ((t0 == 1) && (t1 != 1)) return 2;
/* 113 */     if (!xor(t0 <= 2, t1 <= 2)) return 2;
/* 114 */     if (!xor(t0 == 2, t1 == 2)) { return 2;
/*     */     }
/* 116 */     if ((t0 == 0) && (t1 == 0)) { return 1;
/*     */     }
/* 118 */     return 3;
/*     */   }
/*     */   
/*     */   private static boolean xor(boolean x, boolean y) {
/* 122 */     return ((x) && (y)) || ((!x) && (!y));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected int classify(char c0)
/*     */   {
/* 136 */     switch (Character.getType(c0)) {
/* 137 */     case 1:  return 0;
/* 138 */     case 2:  return 1;
/*     */     case 3: case 4: 
/*     */     case 5: 
/* 141 */       return 2;
/* 142 */     case 9:  return 3; }
/* 143 */     return 4;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public List<String> toWordList(String s)
/*     */   {
/* 158 */     ArrayList<String> ss = new ArrayList();
/* 159 */     int n = s.length();
/* 160 */     for (int i = 0; i < n;)
/*     */     {
/*     */ 
/* 163 */       while ((i < n) && 
/* 164 */         (isPunct(s.charAt(i))))
/*     */       {
/* 166 */         i++;
/*     */       }
/* 168 */       if (i >= n) {
/*     */         break;
/*     */       }
/* 171 */       int b = nextBreak(s, i);
/* 172 */       String w = b == -1 ? s.substring(i) : s.substring(i, b);
/* 173 */       ss.add(escape(capitalize(w)));
/* 174 */       if (b == -1) break;
/* 175 */       i = b;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 182 */     return ss;
/*     */   }
/*     */   
/*     */   protected String toMixedCaseName(List<String> ss, boolean startUpper) {
/* 186 */     StringBuilder sb = new StringBuilder();
/* 187 */     if (!ss.isEmpty()) {
/* 188 */       sb.append(startUpper ? (String)ss.get(0) : ((String)ss.get(0)).toLowerCase());
/* 189 */       for (int i = 1; i < ss.size(); i++)
/* 190 */         sb.append((String)ss.get(i));
/*     */     }
/* 192 */     return sb.toString();
/*     */   }
/*     */   
/*     */ 
/*     */   protected String toMixedCaseVariableName(String[] ss, boolean startUpper, boolean cdrUpper)
/*     */   {
/* 198 */     if (cdrUpper)
/* 199 */       for (int i = 1; i < ss.length; i++)
/* 200 */         ss[i] = capitalize(ss[i]);
/* 201 */     StringBuilder sb = new StringBuilder();
/* 202 */     if (ss.length > 0) {
/* 203 */       sb.append(startUpper ? ss[0] : ss[0].toLowerCase());
/* 204 */       for (int i = 1; i < ss.length; i++)
/* 205 */         sb.append(ss[i]);
/*     */     }
/* 207 */     return sb.toString();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String toConstantName(String s)
/*     */   {
/* 219 */     return toConstantName(toWordList(s));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String toConstantName(List<String> ss)
/*     */   {
/* 230 */     StringBuilder sb = new StringBuilder();
/* 231 */     if (!ss.isEmpty()) {
/* 232 */       sb.append(((String)ss.get(0)).toUpperCase());
/* 233 */       for (int i = 1; i < ss.size(); i++) {
/* 234 */         sb.append('_');
/* 235 */         sb.append(((String)ss.get(i)).toUpperCase());
/*     */       }
/*     */     }
/* 238 */     return sb.toString();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static void escape(StringBuilder sb, String s, int start)
/*     */   {
/* 257 */     int n = s.length();
/* 258 */     for (int i = start; i < n; i++) {
/* 259 */       char c = s.charAt(i);
/* 260 */       if (Character.isJavaIdentifierPart(c)) {
/* 261 */         sb.append(c);
/*     */       } else {
/* 263 */         sb.append('_');
/* 264 */         if (c <= '\017') { sb.append("000");
/* 265 */         } else if (c <= 'ÿ') { sb.append("00");
/* 266 */         } else if (c <= '࿿') sb.append('0');
/* 267 */         sb.append(Integer.toString(c, 16));
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private static String escape(String s)
/*     */   {
/* 277 */     int n = s.length();
/* 278 */     for (int i = 0; i < n; i++)
/* 279 */       if (!Character.isJavaIdentifierPart(s.charAt(i))) {
/* 280 */         StringBuilder sb = new StringBuilder(s.substring(0, i));
/* 281 */         escape(sb, s, i);
/* 282 */         return sb.toString();
/*     */       }
/* 284 */     return s;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static boolean isJavaIdentifier(String s)
/*     */   {
/* 292 */     if (s.length() == 0) return false;
/* 293 */     if (reservedKeywords.contains(s)) { return false;
/*     */     }
/* 295 */     if (!Character.isJavaIdentifierStart(s.charAt(0))) { return false;
/*     */     }
/* 297 */     for (int i = 1; i < s.length(); i++) {
/* 298 */       if (!Character.isJavaIdentifierPart(s.charAt(i)))
/* 299 */         return false;
/*     */     }
/* 301 */     return true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public static boolean isJavaPackageName(String s)
/*     */   {
/* 308 */     while (s.length() != 0) {
/* 309 */       int idx = s.indexOf('.');
/* 310 */       if (idx == -1) idx = s.length();
/* 311 */       if (!isJavaIdentifier(s.substring(0, idx))) {
/* 312 */         return false;
/*     */       }
/* 314 */       s = s.substring(idx);
/* 315 */       if (s.length() != 0) s = s.substring(1);
/*     */     }
/* 317 */     return true;
/*     */   }
/*     */   
/*     */   static
/*     */   {
/* 127 */     for (int t0 = 0; t0 < 5; t0++) {
/* 128 */       for (int t1 = 0; t1 < 5; t1++) {
/* 129 */         actionTable[(t0 * 5 + t1)] = decideAction(t0, t1);
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 322 */     reservedKeywords = new HashSet();
/*     */     
/*     */ 
/*     */ 
/* 326 */     String[] words = { "abstract", "boolean", "break", "byte", "case", "catch", "char", "class", "const", "continue", "default", "do", "double", "else", "extends", "final", "finally", "float", "for", "goto", "if", "implements", "import", "instanceof", "int", "interface", "long", "native", "new", "package", "private", "protected", "public", "return", "short", "static", "strictfp", "super", "switch", "synchronized", "this", "throw", "throws", "transient", "try", "void", "volatile", "while", "true", "false", "null", "assert", "enum" };
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 387 */     for (String word : words) {
/* 388 */       reservedKeywords.add(word);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\api\impl\NameUtil.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */