/*     */ package com.sun.xml.bind.unmarshaller;
/*     */ 
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.LocatorEx;
/*     */ import java.util.Enumeration;
/*     */ import javax.xml.bind.ValidationEventLocator;
/*     */ import javax.xml.bind.helpers.ValidationEventLocatorImpl;
/*     */ import org.w3c.dom.Attr;
/*     */ import org.w3c.dom.Document;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.NamedNodeMap;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.NodeList;
/*     */ import org.w3c.dom.ProcessingInstruction;
/*     */ import org.xml.sax.ContentHandler;
/*     */ import org.xml.sax.Locator;
/*     */ import org.xml.sax.SAXException;
/*     */ import org.xml.sax.helpers.AttributesImpl;
/*     */ import org.xml.sax.helpers.NamespaceSupport;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DOMScanner
/*     */   implements LocatorEx, InfosetScanner
/*     */ {
/*  60 */   private Node currentNode = null;
/*     */   
/*     */ 
/*  63 */   private final AttributesImpl atts = new AttributesImpl();
/*     */   
/*     */ 
/*  66 */   private ContentHandler receiver = null;
/*     */   
/*  68 */   private Locator locator = this;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setLocator(Locator loc)
/*     */   {
/*  78 */     this.locator = loc;
/*     */   }
/*     */   
/*     */   public void scan(Object node) throws SAXException {
/*  82 */     if ((node instanceof Document)) {
/*  83 */       scan((Document)node);
/*     */     } else {
/*  85 */       scan((Element)node);
/*     */     }
/*     */   }
/*     */   
/*     */   public void scan(Document doc) throws SAXException {
/*  90 */     scan(doc.getDocumentElement());
/*     */   }
/*     */   
/*     */   public void scan(Element e) throws SAXException {
/*  94 */     setCurrentLocation(e);
/*  95 */     this.receiver.startDocument();
/*     */     
/*  97 */     this.receiver.setDocumentLocator(this.locator);
/*     */     
/*  99 */     NamespaceSupport nss = new NamespaceSupport();
/* 100 */     buildNamespaceSupport(nss, e.getParentNode());
/*     */     
/* 102 */     for (Enumeration en = nss.getPrefixes(); en.hasMoreElements();) {
/* 103 */       String prefix = (String)en.nextElement();
/* 104 */       this.receiver.startPrefixMapping(prefix, nss.getURI(prefix));
/*     */     }
/*     */     
/* 107 */     visit(e);
/*     */     
/* 109 */     for (Enumeration en = nss.getPrefixes(); en.hasMoreElements();) {
/* 110 */       String prefix = (String)en.nextElement();
/* 111 */       this.receiver.endPrefixMapping(prefix);
/*     */     }
/*     */     
/*     */ 
/* 115 */     setCurrentLocation(e);
/* 116 */     this.receiver.endDocument();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void parse(Element e, ContentHandler handler)
/*     */     throws SAXException
/*     */   {
/* 128 */     this.receiver = handler;
/*     */     
/* 130 */     setCurrentLocation(e);
/* 131 */     this.receiver.startDocument();
/*     */     
/* 133 */     this.receiver.setDocumentLocator(this.locator);
/* 134 */     visit(e);
/*     */     
/* 136 */     setCurrentLocation(e);
/* 137 */     this.receiver.endDocument();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void parseWithContext(Element e, ContentHandler handler)
/*     */     throws SAXException
/*     */   {
/* 148 */     setContentHandler(handler);
/* 149 */     scan(e);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private void buildNamespaceSupport(NamespaceSupport nss, Node node)
/*     */   {
/* 156 */     if ((node == null) || (node.getNodeType() != 1)) {
/* 157 */       return;
/*     */     }
/* 159 */     buildNamespaceSupport(nss, node.getParentNode());
/*     */     
/* 161 */     nss.pushContext();
/* 162 */     NamedNodeMap atts = node.getAttributes();
/* 163 */     for (int i = 0; i < atts.getLength(); i++) {
/* 164 */       Attr a = (Attr)atts.item(i);
/* 165 */       if ("xmlns".equals(a.getPrefix())) {
/* 166 */         nss.declarePrefix(a.getLocalName(), a.getValue());
/*     */ 
/*     */       }
/* 169 */       else if ("xmlns".equals(a.getName())) {
/* 170 */         nss.declarePrefix("", a.getValue());
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void visit(Element e)
/*     */     throws SAXException
/*     */   {
/* 180 */     setCurrentLocation(e);
/* 181 */     NamedNodeMap attributes = e.getAttributes();
/*     */     
/* 183 */     this.atts.clear();
/* 184 */     int len = attributes == null ? 0 : attributes.getLength();
/*     */     
/* 186 */     for (int i = len - 1; i >= 0; i--) {
/* 187 */       Attr a = (Attr)attributes.item(i);
/* 188 */       String name = a.getName();
/*     */       
/* 190 */       if (name.startsWith("xmlns")) {
/* 191 */         if (name.length() == 5) {
/* 192 */           this.receiver.startPrefixMapping("", a.getValue());
/*     */         } else {
/* 194 */           String localName = a.getLocalName();
/* 195 */           if (localName == null)
/*     */           {
/* 197 */             localName = name.substring(6);
/*     */           }
/* 199 */           this.receiver.startPrefixMapping(localName, a.getValue());
/*     */         }
/*     */       }
/*     */       else
/*     */       {
/* 204 */         String uri = a.getNamespaceURI();
/* 205 */         if (uri == null) { uri = "";
/*     */         }
/* 207 */         String local = a.getLocalName();
/* 208 */         if (local == null) { local = a.getName();
/*     */         }
/*     */         
/* 211 */         this.atts.addAttribute(uri, local, a.getName(), "CDATA", a.getValue());
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 219 */     String uri = e.getNamespaceURI();
/* 220 */     if (uri == null) uri = "";
/* 221 */     String local = e.getLocalName();
/* 222 */     String qname = e.getTagName();
/* 223 */     if (local == null) local = qname;
/* 224 */     this.receiver.startElement(uri, local, qname, this.atts);
/*     */     
/*     */ 
/* 227 */     NodeList children = e.getChildNodes();
/* 228 */     int clen = children.getLength();
/* 229 */     for (int i = 0; i < clen; i++) {
/* 230 */       visit(children.item(i));
/*     */     }
/*     */     
/*     */ 
/* 234 */     setCurrentLocation(e);
/* 235 */     this.receiver.endElement(uri, local, qname);
/*     */     
/*     */ 
/* 238 */     for (int i = len - 1; i >= 0; i--) {
/* 239 */       Attr a = (Attr)attributes.item(i);
/* 240 */       String name = a.getName();
/* 241 */       if (name.startsWith("xmlns")) {
/* 242 */         if (name.length() == 5) {
/* 243 */           this.receiver.endPrefixMapping("");
/*     */         } else
/* 245 */           this.receiver.endPrefixMapping(a.getLocalName());
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   private void visit(Node n) throws SAXException {
/* 251 */     setCurrentLocation(n);
/*     */     
/*     */ 
/* 254 */     switch (n.getNodeType()) {
/*     */     case 3: 
/*     */     case 4: 
/* 257 */       String value = n.getNodeValue();
/* 258 */       this.receiver.characters(value.toCharArray(), 0, value.length());
/* 259 */       break;
/*     */     case 1: 
/* 261 */       visit((Element)n);
/* 262 */       break;
/*     */     case 5: 
/* 264 */       this.receiver.skippedEntity(n.getNodeName());
/* 265 */       break;
/*     */     case 7: 
/* 267 */       ProcessingInstruction pi = (ProcessingInstruction)n;
/* 268 */       this.receiver.processingInstruction(pi.getTarget(), pi.getData());
/*     */     }
/*     */   }
/*     */   
/*     */   private void setCurrentLocation(Node currNode)
/*     */   {
/* 274 */     this.currentNode = currNode;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Node getCurrentLocation()
/*     */   {
/* 282 */     return this.currentNode;
/*     */   }
/*     */   
/*     */   public Object getCurrentElement() {
/* 286 */     return this.currentNode;
/*     */   }
/*     */   
/*     */   public LocatorEx getLocator() {
/* 290 */     return this;
/*     */   }
/*     */   
/*     */   public void setContentHandler(ContentHandler handler) {
/* 294 */     this.receiver = handler;
/*     */   }
/*     */   
/*     */   public ContentHandler getContentHandler() {
/* 298 */     return this.receiver;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/* 303 */   public String getPublicId() { return null; }
/* 304 */   public String getSystemId() { return null; }
/* 305 */   public int getLineNumber() { return -1; }
/* 306 */   public int getColumnNumber() { return -1; }
/*     */   
/*     */   public ValidationEventLocator getLocation() {
/* 309 */     return new ValidationEventLocatorImpl(getCurrentLocation());
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\unmarshaller\DOMScanner.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */