/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeTypeInfo;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.DomLoader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.XsiTypeLoader;
/*     */ import java.io.IOException;
/*     */ import javax.xml.bind.annotation.W3CDomHandler;
/*     */ import javax.xml.bind.helpers.ValidationEventImpl;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.w3c.dom.Attr;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.NamedNodeMap;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.NodeList;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class AnyTypeBeanInfo
/*     */   extends JaxBeanInfo<Object>
/*     */ {
/*     */   public AnyTypeBeanInfo(JAXBContextImpl grammar, RuntimeTypeInfo anyTypeInfo)
/*     */   {
/*  33 */     super(grammar, anyTypeInfo, Object.class, new QName("http://www.w3.org/2001/XMLSchema", "anyType"), false, true, false);
/*     */   }
/*     */   
/*     */   public String getElementNamespaceURI(Object element) {
/*  37 */     throw new UnsupportedOperationException();
/*     */   }
/*     */   
/*     */   public String getElementLocalName(Object element) {
/*  41 */     throw new UnsupportedOperationException();
/*     */   }
/*     */   
/*     */   public Object createInstance(UnmarshallingContext context) {
/*  45 */     throw new UnsupportedOperationException();
/*     */   }
/*     */   
/*     */   public boolean reset(Object element, UnmarshallingContext context)
/*     */   {
/*  50 */     return false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getId(Object element, XMLSerializer target)
/*     */   {
/*  61 */     return null;
/*     */   }
/*     */   
/*     */   public void serializeBody(Object element, XMLSerializer target) throws SAXException, IOException, XMLStreamException {
/*  65 */     NodeList childNodes = ((Element)element).getChildNodes();
/*  66 */     int len = childNodes.getLength();
/*  67 */     for (int i = 0; i < len; i++) {
/*  68 */       Node child = childNodes.item(i);
/*  69 */       switch (child.getNodeType()) {
/*     */       case 3: 
/*     */       case 4: 
/*  72 */         target.text(child.getNodeValue(), null);
/*  73 */         break;
/*     */       case 1: 
/*  75 */         target.writeDom((Element)child, domHandler, null, null);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public void serializeAttributes(Object element, XMLSerializer target) throws SAXException
/*     */   {
/*  82 */     NamedNodeMap al = ((Element)element).getAttributes();
/*  83 */     int len = al.getLength();
/*  84 */     for (int i = 0; i < len; i++) {
/*  85 */       Attr a = (Attr)al.item(i);
/*     */       
/*  87 */       String uri = a.getNamespaceURI();
/*  88 */       if (uri == null) uri = "";
/*  89 */       String local = a.getLocalName();
/*  90 */       String name = a.getName();
/*  91 */       if (local == null) { local = name;
/*     */       }
/*  93 */       if (!name.startsWith("xmlns"))
/*     */       {
/*  95 */         target.attribute(uri, local, a.getValue()); }
/*     */     }
/*     */   }
/*     */   
/*     */   public void serializeRoot(Object element, XMLSerializer target) throws SAXException {
/* 100 */     target.reportError(new ValidationEventImpl(1, Messages.UNABLE_TO_MARSHAL_NON_ELEMENT.format(new Object[] { element.getClass().getName() }), null, null));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void serializeURIs(Object element, XMLSerializer target)
/*     */   {
/* 109 */     NamedNodeMap al = ((Element)element).getAttributes();
/* 110 */     int len = al.getLength();
/* 111 */     NamespaceContext2 context = target.getNamespaceContext();
/* 112 */     for (int i = 0; i < len; i++) {
/* 113 */       Attr a = (Attr)al.item(i);
/* 114 */       if ("xmlns".equals(a.getPrefix())) {
/* 115 */         context.declareNamespace(a.getValue(), a.getLocalName(), true);
/*     */ 
/*     */       }
/* 118 */       else if ("xmlns".equals(a.getName())) {
/* 119 */         context.declareNamespace(a.getValue(), "", false);
/*     */       }
/*     */       else {
/* 122 */         String nsUri = a.getNamespaceURI();
/* 123 */         if ((nsUri != null) && (nsUri.length() > 0))
/* 124 */           context.declareNamespace(nsUri, a.getPrefix(), true);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/* 129 */   public Transducer<Object> getTransducer() { return null; }
/*     */   
/*     */   public Loader getLoader(JAXBContextImpl context, boolean typeSubstitutionCapable)
/*     */   {
/* 133 */     if (typeSubstitutionCapable) {
/* 134 */       return this.substLoader;
/*     */     }
/* 136 */     return domLoader;
/*     */   }
/*     */   
/* 139 */   private static final W3CDomHandler domHandler = new W3CDomHandler();
/* 140 */   private static final DomLoader domLoader = new DomLoader(domHandler);
/* 141 */   private final XsiTypeLoader substLoader = new XsiTypeLoader(this);
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\AnyTypeBeanInfo.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */