/*     */ package com.sun.xml.bind.v2.runtime.property;
/*     */ 
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*     */ import com.sun.xml.bind.v2.model.core.TypeRef;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeElementPropertyInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeNonElement;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeTypeRef;
/*     */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*     */ import com.sun.xml.bind.v2.runtime.JaxBeanInfo;
/*     */ import com.sun.xml.bind.v2.runtime.Name;
/*     */ import com.sun.xml.bind.v2.runtime.NameBuilder;
/*     */ import com.sun.xml.bind.v2.runtime.RuntimeUtil;
/*     */ import com.sun.xml.bind.v2.runtime.Transducer;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.ListIterator;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Lister;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Lister.IDREFSIterator;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.NullSafeAccessor;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.ChildLoader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.DefaultValueLoaderDecorator;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Receiver;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.TextLoader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.XsiNilLoader.Array;
/*     */ import com.sun.xml.bind.v2.util.QNameMap;
/*     */ import java.io.IOException;
/*     */ import java.lang.reflect.Type;
/*     */ import java.util.Collection;
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ abstract class ArrayElementProperty<BeanT, ListT, ItemT>
/*     */   extends ArrayERProperty<BeanT, ListT, ItemT>
/*     */ {
/*  44 */   private final Map<Class, TagAndType> typeMap = new HashMap();
/*     */   
/*     */ 
/*     */ 
/*  48 */   private Map<TypeRef<Type, Class>, JaxBeanInfo> refs = new HashMap();
/*     */   
/*     */ 
/*     */   protected RuntimeElementPropertyInfo prop;
/*     */   
/*     */ 
/*     */   private final Name nillableTagName;
/*     */   
/*     */ 
/*     */ 
/*     */   protected ArrayElementProperty(JAXBContextImpl grammar, RuntimeElementPropertyInfo prop)
/*     */   {
/*  60 */     super(grammar, prop, prop.getXmlName(), prop.isCollectionNillable());
/*  61 */     this.prop = prop;
/*     */     
/*  63 */     List<? extends RuntimeTypeRef> types = prop.getTypes();
/*     */     
/*  65 */     Name n = null;
/*     */     
/*  67 */     for (RuntimeTypeRef typeRef : types) {
/*  68 */       Class type = (Class)typeRef.getTarget().getType();
/*  69 */       if (type.isPrimitive()) {
/*  70 */         type = (Class)RuntimeUtil.primitiveToBox.get(type);
/*     */       }
/*  72 */       JaxBeanInfo beanInfo = grammar.getOrCreate(typeRef.getTarget());
/*  73 */       TagAndType tt = new TagAndType(grammar.nameBuilder.createElementName(typeRef.getTagName()), beanInfo);
/*     */       
/*     */ 
/*  76 */       this.typeMap.put(type, tt);
/*  77 */       this.refs.put(typeRef, beanInfo);
/*  78 */       if ((typeRef.isNillable()) && (n == null)) {
/*  79 */         n = tt.tagName;
/*     */       }
/*     */     }
/*  82 */     this.nillableTagName = n;
/*     */   }
/*     */   
/*     */   public void wrapUp()
/*     */   {
/*  87 */     super.wrapUp();
/*  88 */     this.refs = null;
/*  89 */     this.prop = null;
/*     */   }
/*     */   
/*     */   protected void serializeListBody(BeanT beanT, XMLSerializer w, ListT list) throws IOException, XMLStreamException, SAXException, AccessorException {
/*  93 */     ListIterator<ItemT> itr = this.lister.iterator(list, w);
/*     */     
/*  95 */     boolean isIdref = itr instanceof Lister.IDREFSIterator;
/*     */     
/*  97 */     while (itr.hasNext()) {
/*     */       try {
/*  99 */         ItemT item = itr.next();
/* 100 */         if (item != null) {
/* 101 */           Class itemType = item.getClass();
/* 102 */           if (isIdref)
/*     */           {
/*     */ 
/* 105 */             itemType = ((Lister.IDREFSIterator)itr).last().getClass();
/*     */           }
/*     */           
/* 108 */           TagAndType tt = (TagAndType)this.typeMap.get(itemType);
/* 109 */           while ((tt == null) && (itemType != null))
/*     */           {
/* 111 */             itemType = itemType.getSuperclass();
/* 112 */             tt = (TagAndType)this.typeMap.get(itemType);
/*     */           }
/*     */           
/* 115 */           if (tt == null)
/*     */           {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 128 */             w.startElement(((TagAndType)this.typeMap.values().iterator().next()).tagName, null);
/* 129 */             w.childAsXsiType(item, this.fieldName, w.grammar.getBeanInfo(Object.class));
/*     */           } else {
/* 131 */             w.startElement(tt.tagName, null);
/* 132 */             serializeItem(tt.beanInfo, item, w);
/*     */           }
/*     */           
/* 135 */           w.endElement();
/*     */         }
/* 137 */         else if (this.nillableTagName != null) {
/* 138 */           w.startElement(this.nillableTagName, null);
/* 139 */           w.writeXsiNilTrue();
/* 140 */           w.endElement();
/*     */         }
/*     */       }
/*     */       catch (JAXBException e) {
/* 144 */         w.reportError(this.fieldName, e);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected abstract void serializeItem(JaxBeanInfo paramJaxBeanInfo, ItemT paramItemT, XMLSerializer paramXMLSerializer)
/*     */     throws SAXException, AccessorException, IOException, XMLStreamException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void createBodyUnmarshaller(UnmarshallerChain chain, QNameMap<ChildLoader> loaders)
/*     */   {
/* 160 */     int offset = chain.allocateOffset();
/* 161 */     Receiver recv = new ArrayERProperty.ReceiverImpl(this, offset);
/*     */     
/* 163 */     for (RuntimeTypeRef typeRef : this.prop.getTypes())
/*     */     {
/* 165 */       Name tagName = chain.context.nameBuilder.createElementName(typeRef.getTagName());
/* 166 */       Loader item = createItemUnmarshaller(chain, typeRef);
/*     */       
/* 168 */       if (typeRef.isNillable())
/* 169 */         item = new XsiNilLoader.Array(item);
/* 170 */       if (typeRef.getDefaultValue() != null) {
/* 171 */         item = new DefaultValueLoaderDecorator(item, typeRef.getDefaultValue());
/*     */       }
/* 173 */       loaders.put(tagName, new ChildLoader(item, recv));
/*     */     }
/*     */   }
/*     */   
/*     */   public final PropertyKind getKind() {
/* 178 */     return PropertyKind.ELEMENT;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private Loader createItemUnmarshaller(UnmarshallerChain chain, RuntimeTypeRef typeRef)
/*     */   {
/* 195 */     if (PropertyFactory.isLeaf(typeRef.getSource())) {
/* 196 */       Transducer xducer = typeRef.getTransducer();
/* 197 */       return new TextLoader(xducer);
/*     */     }
/* 199 */     return ((JaxBeanInfo)this.refs.get(typeRef)).getLoader(chain.context, true);
/*     */   }
/*     */   
/*     */   public Accessor getElementPropertyAccessor(String nsUri, String localName)
/*     */   {
/* 204 */     if (this.wrapperTagName != null) {
/* 205 */       if (this.wrapperTagName.equals(nsUri, localName))
/* 206 */         return this.acc;
/*     */     } else {
/* 208 */       for (TagAndType tt : this.typeMap.values()) {
/* 209 */         if (tt.tagName.equals(nsUri, localName))
/*     */         {
/*     */ 
/*     */ 
/*     */ 
/* 214 */           return new NullSafeAccessor(this.acc, this.lister); }
/*     */       }
/*     */     }
/* 217 */     return null;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\property\ArrayElementProperty.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */