/*     */ package net.rubyeye.xmemcached.command.text;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import net.rubyeye.xmemcached.command.Command;
/*     */ import net.rubyeye.xmemcached.command.CommandType;
/*     */ import net.rubyeye.xmemcached.impl.MemcachedTCPSession;
/*     */ import net.rubyeye.xmemcached.monitor.Constants;
/*     */ import net.rubyeye.xmemcached.transcoders.CachedData;
/*     */ import net.rubyeye.xmemcached.transcoders.Transcoder;
/*     */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class TextStoreCommand
/*     */   extends Command
/*     */ {
/*     */   protected int expTime;
/*     */   protected long cas;
/*     */   protected Object value;
/*     */   
/*     */   public TextStoreCommand(String key, byte[] keyBytes, CommandType cmdType, CountDownLatch latch, int exp, long cas, Object value, boolean noreply, Transcoder transcoder)
/*     */   {
/*  53 */     super(key, keyBytes, cmdType, latch);
/*  54 */     this.expTime = exp;
/*  55 */     this.cas = cas;
/*  56 */     this.value = value;
/*  57 */     this.noreply = noreply;
/*  58 */     this.transcoder = transcoder;
/*     */   }
/*     */   
/*     */   public final int getExpTime() {
/*  62 */     return this.expTime;
/*     */   }
/*     */   
/*     */   public final void setExpTime(int exp) {
/*  66 */     this.expTime = exp;
/*     */   }
/*     */   
/*     */   public final long getCas() {
/*  70 */     return this.cas;
/*     */   }
/*     */   
/*     */   public final void setCas(long cas) {
/*  74 */     this.cas = cas;
/*     */   }
/*     */   
/*     */   public final Object getValue() {
/*  78 */     return this.value;
/*     */   }
/*     */   
/*     */   public final void setValue(Object value) {
/*  82 */     this.value = value;
/*     */   }
/*     */   
/*     */ 
/*     */   public final Transcoder getTranscoder()
/*     */   {
/*  88 */     return this.transcoder;
/*     */   }
/*     */   
/*     */ 
/*     */   public final void setTranscoder(Transcoder transcoder)
/*     */   {
/*  94 */     this.transcoder = transcoder;
/*     */   }
/*     */   
/*     */   public boolean decode(MemcachedTCPSession session, ByteBuffer buffer)
/*     */   {
/*  99 */     if ((buffer == null) || (!buffer.hasRemaining())) {
/* 100 */       return false;
/*     */     }
/* 102 */     if (this.result == null) {
/* 103 */       if (buffer.remaining() < 2)
/* 104 */         return false;
/* 105 */       byte first = buffer.get(buffer.position());
/* 106 */       byte second = buffer.get(buffer.position() + 1);
/* 107 */       if ((first == 83) && (second == 84)) {
/* 108 */         setResult(Boolean.TRUE);
/* 109 */         countDownLatch();
/*     */         
/* 111 */         return ByteUtils.stepBuffer(buffer, 8); }
/* 112 */       if (first == 78) {
/* 113 */         setResult(Boolean.FALSE);
/* 114 */         countDownLatch();
/*     */         
/* 116 */         return ByteUtils.stepBuffer(buffer, 12);
/*     */       }
/* 118 */       return decodeError(session, buffer);
/*     */     }
/*     */     
/* 121 */     Boolean result = (Boolean)this.result;
/* 122 */     if (result.booleanValue()) {
/* 123 */       return ByteUtils.stepBuffer(buffer, 8);
/*     */     }
/* 125 */     return ByteUtils.stepBuffer(buffer, 12);
/*     */   }
/*     */   
/*     */ 
/*     */   private String getCommandName()
/*     */   {
/* 131 */     switch (this.commandType) {
/*     */     case ADD: 
/* 133 */       return "add";
/*     */     case SET: 
/* 135 */       return "set";
/*     */     case REPLACE: 
/* 137 */       return "replace";
/*     */     case APPEND: 
/* 139 */       return "append";
/*     */     case PREPEND: 
/* 141 */       return "prepend";
/*     */     case CAS: 
/* 143 */       return "cas";
/*     */     }
/* 145 */     throw new IllegalArgumentException(this.commandType.name() + " is not a store command");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void encode()
/*     */   {
/* 153 */     CachedData data = encodeValue();
/* 154 */     String cmdStr = getCommandName();
/* 155 */     byte[] encodedData = data.getData();
/* 156 */     int flag = data.getFlag();
/* 157 */     int size = cmdStr.length() + this.keyBytes.length + ByteUtils.stringSize(flag) + ByteUtils.stringSize(this.expTime) + encodedData.length + ByteUtils.stringSize(encodedData.length) + 8;
/*     */     
/*     */ 
/*     */ 
/* 161 */     if (this.commandType == CommandType.CAS)
/* 162 */       size += 1 + ByteUtils.stringSize(this.cas);
/*     */     byte[] buf;
/*     */     byte[] buf;
/* 165 */     if (isNoreply()) {
/* 166 */       buf = new byte[size + 8];
/*     */     } else {
/* 168 */       buf = new byte[size];
/*     */     }
/* 170 */     int offset = 0;
/* 171 */     if (this.commandType == CommandType.CAS) {
/* 172 */       if (isNoreply()) {
/* 173 */         offset = ByteUtils.setArguments(buf, offset, new Object[] { cmdStr, this.keyBytes, Integer.valueOf(flag), Integer.valueOf(this.expTime), Integer.valueOf(encodedData.length), Long.valueOf(this.cas), Constants.NO_REPLY });
/*     */       }
/*     */       else
/*     */       {
/* 177 */         offset = ByteUtils.setArguments(buf, offset, new Object[] { cmdStr, this.keyBytes, Integer.valueOf(flag), Integer.valueOf(this.expTime), Integer.valueOf(encodedData.length), Long.valueOf(this.cas) });
/*     */       }
/*     */       
/*     */ 
/*     */     }
/* 182 */     else if (isNoreply()) {
/* 183 */       offset = ByteUtils.setArguments(buf, offset, new Object[] { cmdStr, this.keyBytes, Integer.valueOf(flag), Integer.valueOf(this.expTime), Integer.valueOf(encodedData.length), Constants.NO_REPLY });
/*     */     }
/*     */     else
/*     */     {
/* 187 */       offset = ByteUtils.setArguments(buf, offset, new Object[] { cmdStr, this.keyBytes, Integer.valueOf(flag), Integer.valueOf(this.expTime), Integer.valueOf(encodedData.length) });
/*     */     }
/*     */     
/*     */ 
/* 191 */     ByteUtils.setArguments(buf, offset, new Object[] { encodedData });
/* 192 */     this.ioBuffer = IoBuffer.wrap(buf);
/*     */   }
/*     */   
/*     */   protected CachedData encodeValue()
/*     */   {
/* 197 */     CachedData data = this.transcoder.encode(this.value);
/* 198 */     return data;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\text\TextStoreCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */