/*     */ package com.google.code.yanf4j.util;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ShiftOrByteBufferMatcher
/*     */   implements ByteBufferMatcher
/*     */ {
/*     */   private int[] b;
/*     */   private int lim;
/*     */   private int patternLen;
/*     */   
/*     */   public ShiftOrByteBufferMatcher(IoBuffer pat)
/*     */   {
/*  48 */     if ((pat == null) || (pat.remaining() == 0)) {
/*  49 */       throw new IllegalArgumentException("blank buffer");
/*     */     }
/*  51 */     this.patternLen = pat.remaining();
/*  52 */     preprocess(pat);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void preprocess(IoBuffer pat)
/*     */   {
/*  62 */     this.b = new int['Ā'];
/*  63 */     this.lim = 0;
/*  64 */     for (int i = 0; i < 256; i++) {
/*  65 */       this.b[i] = -1;
/*     */     }
/*     */     
/*  68 */     int i = 0; for (int j = 1; i < this.patternLen; j <<= 1) {
/*  69 */       this.b[ByteBufferUtils.uByte(pat.get(i))] &= (j ^ 0xFFFFFFFF);
/*  70 */       this.lim |= j;i++;
/*     */     }
/*     */     
/*  72 */     this.lim = (this.lim >> 1 ^ 0xFFFFFFFF);
/*     */   }
/*     */   
/*     */ 
/*     */   public final List<Integer> matchAll(IoBuffer buffer)
/*     */   {
/*  78 */     List<Integer> matches = new ArrayList();
/*  79 */     int bufferLimit = buffer.limit();
/*  80 */     int state = -1;
/*  81 */     for (int pos = buffer.position(); pos < bufferLimit; pos++) {
/*  82 */       state <<= 1;
/*  83 */       state |= this.b[ByteBufferUtils.uByte(buffer.get(pos))];
/*  84 */       if (state < this.lim) {
/*  85 */         matches.add(Integer.valueOf(pos - this.patternLen + 1));
/*     */       }
/*     */     }
/*  88 */     return matches;
/*     */   }
/*     */   
/*     */   public final int matchFirst(IoBuffer buffer)
/*     */   {
/*  93 */     if (buffer == null) {
/*  94 */       return -1;
/*     */     }
/*  96 */     int bufferLimit = buffer.limit();
/*  97 */     int state = -1;
/*  98 */     for (int pos = buffer.position(); pos < bufferLimit; pos++) {
/*  99 */       state = state <<= 1 | this.b[ByteBufferUtils.uByte(buffer.get(pos))];
/* 100 */       if (state < this.lim) {
/* 101 */         return pos - this.patternLen + 1;
/*     */       }
/*     */     }
/* 104 */     return -1;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\google\code\yanf4j\util\ShiftOrByteBufferMatcher.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */