package com.jaspersoft.jasperserver.api.engine.scheduling.service;

import com.jaspersoft.jasperserver.api.JasperServerAPI;
import com.jaspersoft.jasperserver.api.common.domain.ExecutionContext;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJob;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobIdHolder;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobSummary;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.reportjobmodel.ReportJobModel;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.reportjobmodel.ReportJobModel.ReportJobSortType;
import java.util.List;

@JasperServerAPI
public abstract interface ReportJobsPersistenceService
{
  public abstract ReportJob saveJob(ExecutionContext paramExecutionContext, ReportJob paramReportJob);
  
  public abstract ReportJob updateJob(ExecutionContext paramExecutionContext, ReportJob paramReportJob)
    throws ReportJobNotFoundException;
  
  public abstract List<ReportJobIdHolder> updateJobsByID(ExecutionContext paramExecutionContext, List<ReportJobIdHolder> paramList, ReportJobModel paramReportJobModel, boolean paramBoolean)
    throws TriggerTypeMismatchException, ReportJobNotFoundException, DuplicateOutputLocationException;
  
  public abstract List<ReportJob> updateJobs(ExecutionContext paramExecutionContext, List<ReportJob> paramList, ReportJobModel paramReportJobModel, boolean paramBoolean)
    throws TriggerTypeMismatchException, ReportJobNotFoundException, DuplicateOutputLocationException;
  
  public abstract ReportJob loadJob(ExecutionContext paramExecutionContext, ReportJobIdHolder paramReportJobIdHolder);
  
  public abstract List<ReportJob> loadJobs(ExecutionContext paramExecutionContext, List<ReportJobIdHolder> paramList);
  
  public abstract void deleteJob(ExecutionContext paramExecutionContext, ReportJobIdHolder paramReportJobIdHolder);
  
  public abstract List listJobs(ExecutionContext paramExecutionContext, String paramString);
  
  public abstract List<ReportJobSummary> listJobs(ExecutionContext paramExecutionContext, List<ReportJob> paramList);
  
  public abstract List<ReportJobSummary> listJobs(ExecutionContext paramExecutionContext, ReportJobModel paramReportJobModel, int paramInt1, int paramInt2, ReportJobModel.ReportJobSortType paramReportJobSortType, boolean paramBoolean);
  
  public abstract List listJobs(ExecutionContext paramExecutionContext);
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-api-engine-6.0.jar!\com\jaspersoft\jasperserver\api\engine\scheduling\service\ReportJobsPersistenceService.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */