/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.attributes;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestBuilder;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.dto.attributes.ServerAttributesListWrapper;
/*    */ import java.util.Arrays;
/*    */ import java.util.Collection;
/*    */ import java.util.Collections;
/*    */ import javax.ws.rs.core.MultivaluedHashMap;
/*    */ import javax.ws.rs.core.MultivaluedMap;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ServerBatchAttributeAdapter
/*    */   extends AbstractAdapter
/*    */ {
/*    */   private MultivaluedMap<String, String> params;
/*    */   
/*    */   public ServerBatchAttributeAdapter(SessionStorage sessionStorage, Collection<String> attributesNames)
/*    */   {
/* 46 */     super(sessionStorage);
/* 47 */     this.params = new MultivaluedHashMap();
/* 48 */     for (String attributeName : attributesNames) {
/* 49 */       this.params.add("name", attributeName);
/*    */     }
/*    */   }
/*    */   
/*    */   public ServerBatchAttributeAdapter(SessionStorage sessionStorage) {
/* 54 */     this(sessionStorage, Collections.emptyList());
/*    */   }
/*    */   
/*    */   public ServerBatchAttributeAdapter(SessionStorage sessionStorage, String... attributesNames) {
/* 58 */     this(sessionStorage, Arrays.asList(attributesNames));
/*    */   }
/*    */   
/*    */   public OperationResult<ServerAttributesListWrapper> get() {
/* 62 */     return request().addParams(this.params).get();
/*    */   }
/*    */   
/*    */   public OperationResult<ServerAttributesListWrapper> delete() {
/* 66 */     return request().addParams(this.params).delete();
/*    */   }
/*    */   
/*    */   public OperationResult<ServerAttributesListWrapper> createOrUpdate(ServerAttributesListWrapper attributesListWrapper) {
/* 70 */     return request().put(attributesListWrapper);
/*    */   }
/*    */   
/*    */   private JerseyRequest<ServerAttributesListWrapper> request() {
/* 74 */     return JerseyRequest.buildRequest(this.sessionStorage, ServerAttributesListWrapper.class, new String[] { "/attributes" }, new DefaultErrorHandler());
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\attributes\ServerBatchAttributeAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */