/*    */ package com.netapp.asup.data.function.aggregation;
/*    */ 
/*    */ import com.netapp.asup.client.arma.data.ARMAObjectInstance;
/*    */ import com.netapp.asup.common.AsupLogger;
/*    */ import com.netapp.asup.data.function.TypeConverter;
/*    */ import com.netapp.asup.exception.ARMAException;
/*    */ import java.lang.reflect.InvocationTargetException;
/*    */ import java.util.Map;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ import org.apache.avro.util.Utf8;
/*    */ import org.codehaus.commons.compiler.CompileException;
/*    */ import org.codehaus.janino.ExpressionEvaluator;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ExpressionAggregator<T>
/*    */   extends Aggregator<T>
/*    */ {
/*    */   private final Object[] arguments;
/*    */   private final ExpressionEvaluator eval;
/*    */   
/*    */   ExpressionAggregator(AggregationType type, GenericRecord aggregationField)
/*    */     throws ARMAException
/*    */   {
/* 32 */     super(type, aggregationField);
/* 33 */     this.arguments = new Object[this.attributes.length];
/*    */     try {
/* 35 */       this.eval = new ExpressionEvaluator(this.expression, Object.class, this.attributes, this.attributeTypes);
/*    */     } catch (CompileException e) {
/* 37 */       throw new ARMAException(logger, this.type.getName(), "Invalid expression caused by :" + e.getCause(), e);
/*    */     }
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public void compute(ARMAObjectInstance instance)
/*    */     throws ARMAException
/*    */   {
/*    */     try
/*    */     {
/* 48 */       boolean evaluate = true;
/* 49 */       for (int index = 0; index < this.attributes.length; index++) {
/* 50 */         String attribute = instance.getAllAttribute(this.attributes[index]);
/* 51 */         if (attribute != null) {
/* 52 */           this.arguments[index] = ((Converter)TypeConverter.getConvertorclassmap().get(this.attributeTypes[index])).convert(attribute);
/*    */         } else {
/* 54 */           evaluate = false;
/* 55 */           logger.warn(instance.getKey().toString(), "Attribute :" + this.attributes[index] + " has null value");
/* 56 */           break;
/*    */         }
/*    */       }
/* 59 */       if (evaluate) {
/* 60 */         Object result = this.eval.evaluate(this.arguments);
/* 61 */         if (result != null) {
/* 62 */           super.compute(result.toString());
/*    */         }
/*    */       }
/*    */     } catch (InvocationTargetException e) {
/* 66 */       throw new ARMAException(logger, this.type.getName(), "Error in execution of expression :" + e.getCause(), e);
/*    */     }
/*    */   }
/*    */   
/*    */   public static abstract interface Converter<T>
/*    */   {
/*    */     public abstract T convert(String paramString);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\aggregation\ExpressionAggregator.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */