/*     */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*     */ 
/*     */ import com.sun.xml.bind.v2.util.FatalAdapter;
/*     */ import javax.xml.namespace.NamespaceContext;
/*     */ import javax.xml.validation.Schema;
/*     */ import javax.xml.validation.ValidatorHandler;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class ValidatingUnmarshaller
/*     */   implements XmlVisitor, XmlVisitor.TextPredictor
/*     */ {
/*     */   private final XmlVisitor next;
/*     */   private final ValidatorHandler validator;
/*     */   private final XmlVisitor.TextPredictor predictor;
/*  45 */   private char[] buf = new char['Ā'];
/*     */   
/*     */ 
/*     */ 
/*     */   public ValidatingUnmarshaller(Schema schema, XmlVisitor next)
/*     */   {
/*  51 */     this.validator = schema.newValidatorHandler();
/*  52 */     this.next = next;
/*  53 */     this.predictor = next.getPredictor();
/*     */     
/*     */ 
/*  56 */     this.validator.setErrorHandler(new FatalAdapter(getContext()));
/*     */   }
/*     */   
/*     */   public void startDocument(LocatorEx locator, NamespaceContext nsContext)
/*     */     throws SAXException
/*     */   {
/*  62 */     this.validator.setDocumentLocator(locator);
/*  63 */     this.validator.startDocument();
/*  64 */     this.next.startDocument(locator, nsContext);
/*     */   }
/*     */   
/*     */   public void endDocument() throws SAXException {
/*  68 */     this.validator.endDocument();
/*  69 */     this.next.endDocument();
/*     */   }
/*     */   
/*     */   public void startElement(TagName tagName) throws SAXException {
/*  73 */     this.validator.startElement(tagName.uri, tagName.local, tagName.getQname(), tagName.atts);
/*  74 */     this.next.startElement(tagName);
/*     */   }
/*     */   
/*     */   public void endElement(TagName tagName) throws SAXException {
/*  78 */     this.validator.endElement(tagName.uri, tagName.local, tagName.getQname());
/*  79 */     this.next.endElement(tagName);
/*     */   }
/*     */   
/*     */   public void startPrefixMapping(String prefix, String nsUri) throws SAXException {
/*  83 */     this.validator.startPrefixMapping(prefix, nsUri);
/*  84 */     this.next.startPrefixMapping(prefix, nsUri);
/*     */   }
/*     */   
/*     */   public void endPrefixMapping(String prefix) throws SAXException {
/*  88 */     this.validator.endPrefixMapping(prefix);
/*  89 */     this.next.endPrefixMapping(prefix);
/*     */   }
/*     */   
/*     */   public void text(CharSequence pcdata) throws SAXException {
/*  93 */     int len = pcdata.length();
/*  94 */     if (this.buf.length < len) {
/*  95 */       this.buf = new char[len];
/*     */     }
/*  97 */     for (int i = 0; i < len; i++) {
/*  98 */       this.buf[i] = pcdata.charAt(i);
/*     */     }
/* 100 */     this.validator.characters(this.buf, 0, len);
/* 101 */     if (this.predictor.expectText())
/* 102 */       this.next.text(pcdata);
/*     */   }
/*     */   
/*     */   public UnmarshallingContext getContext() {
/* 106 */     return this.next.getContext();
/*     */   }
/*     */   
/*     */   public XmlVisitor.TextPredictor getPredictor() {
/* 110 */     return this;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   @Deprecated
/*     */   public boolean expectText()
/*     */   {
/* 119 */     return true;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\ValidatingUnmarshaller.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */