/*     */ package org.apache.avro.io;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.nio.ByteBuffer;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class BinaryEncoder
/*     */   extends Encoder
/*     */ {
/*     */   public void writeNull()
/*     */     throws IOException
/*     */   {}
/*     */   
/*     */   public void writeString(Utf8 utf8)
/*     */     throws IOException
/*     */   {
/*  44 */     writeBytes(utf8.getBytes(), 0, utf8.getByteLength());
/*     */   }
/*     */   
/*     */   public void writeString(String string) throws IOException
/*     */   {
/*  49 */     if (0 == string.length()) {
/*  50 */       writeZero();
/*  51 */       return;
/*     */     }
/*  53 */     byte[] bytes = string.getBytes("UTF-8");
/*  54 */     writeInt(bytes.length);
/*  55 */     writeFixed(bytes, 0, bytes.length);
/*     */   }
/*     */   
/*     */   public void writeBytes(ByteBuffer bytes) throws IOException
/*     */   {
/*  60 */     int len = bytes.limit() - bytes.position();
/*  61 */     if (0 == len) {
/*  62 */       writeZero();
/*     */     } else {
/*  64 */       writeInt(len);
/*  65 */       writeFixed(bytes);
/*     */     }
/*     */   }
/*     */   
/*     */   public void writeBytes(byte[] bytes, int start, int len) throws IOException
/*     */   {
/*  71 */     if (0 == len) {
/*  72 */       writeZero();
/*  73 */       return;
/*     */     }
/*  75 */     writeInt(len);
/*  76 */     writeFixed(bytes, start, len);
/*     */   }
/*     */   
/*     */   public void writeEnum(int e) throws IOException
/*     */   {
/*  81 */     writeInt(e);
/*     */   }
/*     */   
/*     */   public void writeArrayStart() throws IOException
/*     */   {}
/*     */   
/*     */   public void setItemCount(long itemCount) throws IOException
/*     */   {
/*  89 */     if (itemCount > 0L) {
/*  90 */       writeLong(itemCount);
/*     */     }
/*     */   }
/*     */   
/*     */   public void startItem() throws IOException
/*     */   {}
/*     */   
/*     */   public void writeArrayEnd() throws IOException
/*     */   {
/*  99 */     writeZero();
/*     */   }
/*     */   
/*     */   public void writeMapStart() throws IOException
/*     */   {}
/*     */   
/*     */   public void writeMapEnd() throws IOException
/*     */   {
/* 107 */     writeZero();
/*     */   }
/*     */   
/*     */   public void writeIndex(int unionIndex) throws IOException
/*     */   {
/* 112 */     writeInt(unionIndex);
/*     */   }
/*     */   
/*     */   protected abstract void writeZero()
/*     */     throws IOException;
/*     */   
/*     */   public abstract int bytesBuffered();
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\io\BinaryEncoder.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */