/*     */ package org.codehaus.jackson.map.introspect;
/*     */ 
/*     */ import java.lang.annotation.Annotation;
/*     */ import java.lang.reflect.Type;
/*     */ import java.lang.reflect.TypeVariable;
/*     */ import org.codehaus.jackson.map.type.TypeBindings;
/*     */ import org.codehaus.jackson.map.type.TypeFactory;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class AnnotatedWithParams
/*     */   extends AnnotatedMember
/*     */ {
/*     */   protected final AnnotationMap _annotations;
/*     */   protected final AnnotationMap[] _paramAnnotations;
/*     */   
/*     */   protected AnnotatedWithParams(AnnotationMap classAnn, AnnotationMap[] paramAnnotations)
/*     */   {
/*  38 */     this._annotations = classAnn;
/*  39 */     this._paramAnnotations = paramAnnotations;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void addOrOverride(Annotation a)
/*     */   {
/*  48 */     this._annotations.add(a);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void addOrOverrideParam(int paramIndex, Annotation a)
/*     */   {
/*  59 */     AnnotationMap old = this._paramAnnotations[paramIndex];
/*  60 */     if (old == null) {
/*  61 */       old = new AnnotationMap();
/*  62 */       this._paramAnnotations[paramIndex] = old;
/*     */     }
/*  64 */     old.add(a);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void addIfNotPresent(Annotation a)
/*     */   {
/*  74 */     this._annotations.addIfNotPresent(a);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected JavaType getType(TypeBindings bindings, TypeVariable<?>[] typeParams)
/*     */   {
/*  86 */     if ((typeParams != null) && (typeParams.length > 0)) {
/*  87 */       bindings = bindings.childInstance();
/*  88 */       for (TypeVariable<?> var : typeParams) {
/*  89 */         String name = var.getName();
/*     */         
/*  91 */         bindings._addPlaceholder(name);
/*     */         
/*  93 */         Type lowerBound = var.getBounds()[0];
/*  94 */         JavaType type = lowerBound == null ? TypeFactory.unknownType() : bindings.resolveType(lowerBound);
/*     */         
/*  96 */         bindings.addBinding(var.getName(), type);
/*     */       }
/*     */     }
/*  99 */     return bindings.resolveType(getGenericType());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final <A extends Annotation> A getAnnotation(Class<A> acls)
/*     */   {
/* 111 */     return this._annotations.get(acls);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final AnnotationMap getParameterAnnotations(int index)
/*     */   {
/* 122 */     if ((this._paramAnnotations != null) && 
/* 123 */       (index >= 0) && (index <= this._paramAnnotations.length)) {
/* 124 */       return this._paramAnnotations[index];
/*     */     }
/*     */     
/* 127 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */   public abstract AnnotatedParameter getParameter(int paramInt);
/*     */   
/*     */ 
/*     */   public abstract int getParameterCount();
/*     */   
/*     */ 
/*     */   public abstract Class<?> getParameterClass(int paramInt);
/*     */   
/*     */ 
/*     */   public abstract Type getParameterType(int paramInt);
/*     */   
/*     */ 
/*     */   public final JavaType resolveParameterType(int index, TypeBindings bindings)
/*     */   {
/* 145 */     return bindings.resolveType(getParameterType(index));
/*     */   }
/*     */   
/* 148 */   public final int getAnnotationCount() { return this._annotations.size(); }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\introspect\AnnotatedWithParams.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */