package prefuse.controls;

import java.awt.event.MouseEvent;
import prefuse.Display;
import prefuse.visual.VisualItem;

public class ToolTipControl
  extends ControlAdapter
{
  private String[] label;
  private StringBuffer sbuf;
  
  public ToolTipControl(String paramString)
  {
    this(new String[] { paramString });
  }
  
  public ToolTipControl(String[] paramArrayOfString)
  {
    this.label = paramArrayOfString;
    if (paramArrayOfString.length > 1) {
      this.sbuf = new StringBuffer();
    }
  }
  
  public void itemEntered(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    Display localDisplay = (Display)paramMouseEvent.getSource();
    if (this.label.length == 1)
    {
      if (paramVisualItem.canGetString(this.label[0])) {
        localDisplay.setToolTipText(paramVisualItem.getString(this.label[0]));
      }
    }
    else
    {
      this.sbuf.delete(0, this.sbuf.length());
      for (int i = 0; i < this.label.length; i++) {
        if (paramVisualItem.canGetString(this.label[i]))
        {
          if (this.sbuf.length() > 0) {
            this.sbuf.append("; ");
          }
          this.sbuf.append(paramVisualItem.getString(this.label[i]));
        }
      }
      localDisplay.setToolTipText(this.sbuf.toString());
    }
  }
  
  public void itemExited(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    Display localDisplay = (Display)paramMouseEvent.getSource();
    localDisplay.setToolTipText(null);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\controls\ToolTipControl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */