package prefuse.data.util;

import prefuse.data.CascadedTable;
import prefuse.data.Table;
import prefuse.data.column.IntColumn;
import prefuse.util.collections.IntIntSortedMap;
import prefuse.util.collections.IntIntTreeMap;

public class FilteredRowManager
  extends RowManager
{
  protected IntColumn m_childToParent;
  protected IntIntSortedMap m_parentToChild;
  
  public FilteredRowManager(Table paramTable)
  {
    super(paramTable);
    this.m_childToParent = new IntColumn(paramTable.getRowCount());
    this.m_parentToChild = new IntIntTreeMap(false);
    clear();
  }
  
  public void clear()
  {
    super.clear();
    this.m_parentToChild.clear();
    for (int i = 0; i < this.m_childToParent.getRowCount(); i++) {
      this.m_childToParent.setInt(-1, i);
    }
  }
  
  public int addRow(int paramInt)
  {
    int i = super.addRow();
    put(i, paramInt);
    return i;
  }
  
  public boolean releaseRow(int paramInt)
  {
    if (super.releaseRow(paramInt))
    {
      remove(paramInt);
      return true;
    }
    return false;
  }
  
  public int getColumnRow(int paramInt1, int paramInt2)
  {
    return ((CascadedTable)this.m_table).getParentTable().getColumnRow(getParentRow(paramInt1), paramInt2);
  }
  
  public int getTableRow(int paramInt1, int paramInt2)
  {
    return getChildRow(paramInt1);
  }
  
  public int getParentRow(int paramInt)
  {
    if (paramInt >= this.m_childToParent.getRowCount()) {
      return -1;
    }
    return this.m_childToParent.getInt(paramInt);
  }
  
  public int getChildRow(int paramInt)
  {
    int i = this.m_parentToChild.get(paramInt);
    return i == Integer.MIN_VALUE ? -1 : i;
  }
  
  public void put(int paramInt1, int paramInt2)
  {
    if (paramInt1 >= this.m_childToParent.getRowCount()) {
      this.m_childToParent.setMaximumRow(paramInt1 + 1);
    }
    this.m_childToParent.setInt(paramInt2, paramInt1);
    this.m_parentToChild.put(paramInt2, paramInt1);
  }
  
  public void remove(int paramInt)
  {
    int i = this.m_childToParent.getInt(paramInt);
    this.m_childToParent.setInt(-1, paramInt);
    this.m_parentToChild.remove(i);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\util\FilteredRowManager.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */