package prefuse.util.collections;

public class DefaultLiteralComparator
  implements LiteralComparator
{
  private static DefaultLiteralComparator s_instance = null;
  
  public static DefaultLiteralComparator getInstance()
  {
    if (s_instance == null) {
      s_instance = new DefaultLiteralComparator();
    }
    return s_instance;
  }
  
  public int compare(int paramInt1, int paramInt2)
  {
    return paramInt1 > paramInt2 ? 1 : paramInt1 < paramInt2 ? -1 : 0;
  }
  
  public int compare(long paramLong1, long paramLong2)
  {
    return paramLong1 > paramLong2 ? 1 : paramLong1 < paramLong2 ? -1 : 0;
  }
  
  public int compare(float paramFloat1, float paramFloat2)
  {
    return Float.compare(paramFloat1, paramFloat2);
  }
  
  public int compare(double paramDouble1, double paramDouble2)
  {
    return Double.compare(paramDouble1, paramDouble2);
  }
  
  public int compare(boolean paramBoolean1, boolean paramBoolean2)
  {
    return paramBoolean2 ? -1 : paramBoolean1 ? 1 : paramBoolean2 ? 0 : 0;
  }
  
  public int compare(Object paramObject1, Object paramObject2)
  {
    if (paramObject1 == null) {
      return paramObject2 == null ? 0 : -1;
    }
    if (paramObject2 == null) {
      return 1;
    }
    if ((paramObject1 instanceof Comparable)) {
      return ((Comparable)paramObject1).compareTo(paramObject2);
    }
    if ((paramObject2 instanceof Comparable)) {
      return -1 * ((Comparable)paramObject2).compareTo(paramObject1);
    }
    throw new IllegalArgumentException("Incomparable arguments.");
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\collections\DefaultLiteralComparator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */